/**************************************************************/
/*                                                            */
/*                   nsl_cmd_input_3d.C                   */
/*                                                            */
/**************************************************************/

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_cmd_input_3d::nsl_cmd_input_3d()
{
	set_type("input_3d");
}

nsl_cmd_input_3d::~nsl_cmd_input_3d()
{
}

int nsl_cmd_input_3d::cmd_clear(nsl_interpreter&)
{
	return 1;
}
int nsl_cmd_input_3d::cmd_create(nsl_interpreter&)
{
	return 1;
}
int nsl_cmd_input_3d::cmd_reset(nsl_interpreter&)
{
	nsl_base* pbase;
	if ((pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type("input_layer")) != NULL &&
	     (OBJ = pbase->get_ptr()) != NULL)
	{
		((nsl_input_3d*) OBJ)->get_input_layer()->reset(0);
	}
 
	return 1;
}
int nsl_cmd_input_3d::cmd_update(nsl_interpreter&)
{
 	update_data(OBJ);

	return 1;
}
int nsl_cmd_input_3d::init_data(nsl_base* layer)
{
	num_type fval = 0.0;
 	nsl_cmd_type* data;
 	nsl_base* pbase;
	nsl_list* list = 0;

	if (layer == NULL)
	{
		cmd_error("cmd: NULL OBJ");
		return 1;
	}

	nsl_cmd_input_matrix::init_data(layer);

	nsl_input_layer* in_stim = ((nsl_input_3d*) layer)->get_input_layer();

   	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type("input_layer");
	if (pbase != NULL && in_stim != NULL)
	{
		list = ((nsl_cmd_type*) pbase)->get_data_list();
		((nsl_cmd_layer*) pbase)->update_data(in_stim);
	}
	else
		cmd_error("cmd_stim: NULL stim parent type");

	if (list != NULL && layer != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("angle")) != NULL)
	  {
		fval = ((nsl_input_3d*) layer)->get_angle();
		((nsl_num_data*) data)->set_value(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'angle' obj");
	  if ((data = (nsl_cmd_type*) list->get_by_name("transx")) != NULL)
	  {
		fval = ((nsl_input_3d*) layer)->get_transx();
		((nsl_num_data*) data)->set_value(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'transx' obj");
	  if ((data = (nsl_cmd_type*) list->get_by_name("transy")) != NULL)
	  {
		fval = ((nsl_input_3d*) layer)->get_transy();
		((nsl_num_data*) data)->set_value(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'transy' obj");
 	}
	else
		cmd_error("NULL OBJ");

	return 1;
}
int nsl_cmd_input_3d::update_data(nsl_base* layer,
	int,int,int,int,int,int,int,int,int,int)
{
	int ival = 0;
	num_type fval = 0.0;
 	nsl_cmd_type* data;
 	nsl_base* pbase;
	nsl_list* list = 0;

	if (layer == NULL)
	{
		cmd_error("cmd: NULL OBJ");
		return 1;
	}

	nsl_cmd_input_matrix::update_data(layer);

	nsl_input_layer* in_stim = ((nsl_input_3d*) layer)->get_input_layer();

  	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type("input_layer");
	if (pbase != NULL && in_stim != NULL)
	{
		list = ((nsl_cmd_type*) pbase)->get_data_list();
		((nsl_cmd_layer*) pbase)->update_data(in_stim);
	}
	else
		cmd_error("cmd_stim: NULL stim parent type");

	if (list != NULL && layer != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("angle")) != NULL)
	  {
		fval = ((nsl_num_data*) data)->get_value();
		((nsl_input_3d*) layer)->set_angle(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'angle' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("transx")) != NULL)
	  {
		fval = ((nsl_num_data*) data)->get_value();
		((nsl_input_3d*) layer)->set_transx(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'transx' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("transy")) != NULL)
	  {
		fval = ((nsl_num_data*) data)->get_value();
		((nsl_input_3d*) layer)->set_transy(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'transy' obj");
	}
	else
		cmd_error("NULL OBJ");

	return 1;
}
