/* SCCS  @(#)nsl_mat_to_vec_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_mat_to_vec_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> nslReduce(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> nslReduceCols(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> nslReduceRows(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> nslReduceCols(const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> nslReduceRows(const nsl_num_2<NslNumType,NslTypeId>&);

extern nsl_num_1<NslNumType,NslTypeId> NSLmat_to_vec(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmat_to_col_vec(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmat_to_row_vec(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmat_to_col_vec(const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLmat_to_row_vec(const nsl_num_2<NslNumType,NslTypeId>&);
*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> nslReduce(const nsl_num_1<NslNumType,NslTypeId>& ref,const nsl_num_2<NslNumType,NslTypeId>& a) // NSLmat_to_vec
{
	int vec_type = ref.get_vec_type();

	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	int s = ref.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(s);
	
	if (vec_type == 0) // row vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[j] = a[i][j] + c[j];
	}
	if (vec_type == 1) // col vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[i] = a[i][j] + c[i];
	}

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> nslReduceRows(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>& a) // NSLmat_to_row_vec
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_num_1<NslNumType,NslTypeId> c(sjmax);
		
	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		c[j] = a[i][j] + c[j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> nslReduceCols(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>& a) // NSLmat_to_col_vec
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_num_1<NslNumType,NslTypeId> c(simax);
	
	for (int j = 0; j < sjmax; j++)
	    for (int i = 0; i < simax; i++)
		c[i] = a[i][j] + c[i];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> nslReduceRows(const nsl_num_2<NslNumType,NslTypeId>& a) // NSLmat_to_row_vec
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_num_1<NslNumType,NslTypeId> c(sjmax);
		
	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		c[j] = a[i][j] + c[j];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> nslReduceCols(const nsl_num_2<NslNumType,NslTypeId>& a) // NSLmat_to_col_vec
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_num_1<NslNumType,NslTypeId> c(simax);
	
	for (int j = 0; j < sjmax; j++)
	    for (int i = 0; i < simax; i++)
		c[i] = a[i][j] + c[i];

	return c;
}

