/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_div_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_2<NslNumType,NslTypeId>_div_library.h
//
/*
extern	nsl_num_2<NslNumType,NslTypeId> 	operator/(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator/(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator/(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator/(const nsl_num_2<NslNumType,NslTypeId>&,const num_type);
extern	nsl_num_2<NslNumType,NslTypeId> 	operator/(const num_type,const nsl_num_2<NslNumType,NslTypeId>&);
*/

// matrix pointwise division

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (matrix) " << a.get_name() << " / (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
	   {
		if (b[i][j] == 0)
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error("Division by zero");
			return c;
		}
		c[i][j] = a[i][j] / b[i][j];
	   }

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (matrix) " << a.get_name() << " / (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
		cmd_error("b: ",b);
		cmd_error("Division by zero");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (matrix) " << a.get_name() << " / (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
		cmd_error("b: ",b);
		cmd_error("Division by zero");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / (float) b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (matrix) " << a.get_name() << " / (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
		cmd_error("b: ",b);
		cmd_error("Division by zero");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / (float) b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const float a,const  nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (num_type) " << a << " / (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b[i][j] == 0)
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error("Division by zero");
			return c;
		}
		c[i][j] = a / b[i][j];
	   }

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const double a,const  nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (num_type) " << a << " / (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b[i][j] == 0)
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error("Division by zero");
			return c;
		}
		c[i][j] = a / b[i][j];
	   }

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const int a,const  nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (num_type) " << a << " / (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b[i][j] == 0)
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error("Division by zero");
			return c;
		}
		c[i][j] = a / b[i][j];
	   }

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (matrix) " << a.get_name() << " / (data) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	num_type   Vb = b.get_data();

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
		b.print_status(cerr);
		b.print(cerr);
		cmd_error("Division by zero");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> operator/(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_2<NslNumType,NslTypeId> operator/\n";
        cout << "// (data) " << a.get_name() << " / (matrix) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b[i][j] == 0)
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::operator/ ***");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error("Division by zero");
			return c;
		}
		c[i][j] = a.get_data() / b[i][j];
	   }

	return c;
}


// matrix pointwise division

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent matrix sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		if (b[i][j] != 0)
			c[i][j] = a[i][j] / b[i][j];
		else
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
			b.print_status(cerr);
			b.print(cerr);			
			cmd_error("DIVISION by 0");
			return c;
		}

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");	
		cmd_error("DIVISION by 0");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");	
		cmd_error("DIVISION by 0");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");	
		cmd_error("DIVISION by 0");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const float a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		if (b[i][j] != 0)
			c[i][j] = a / b[i][j];
		else
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
			b.print_status(cerr);
			b.print(cerr);			
			cmd_error("DIVISION by 0");
			return c;
		}

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const double a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		if (b[i][j] != 0)
			c[i][j] = a / b[i][j];
		else
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
			b.print_status(cerr);
			b.print(cerr);			
			cmd_error("DIVISION by 0");
			return c;
		}

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const int a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		if (b[i][j] != 0)
			c[i][j] = a / b[i][j];
		else
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
			b.print_status(cerr);
			b.print(cerr);			
			cmd_error("DIVISION by 0");
			return c;
		}

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(aimax,ajmax);

	if (b == 0)
	{
		cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
		b.print_status(cerr);
		b.print(cerr);			
		cmd_error("DIVISION by 0");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c[i][j] = a[i][j] / b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLdiv(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_num_2<NslNumType,NslTypeId> c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		if (b[i][j] != 0)
			c[i][j] = a.get_data() / b[i][j];
		else
		{
			cmd_error("*** nsl_num_2<NslNumType,NslTypeId>::NSLdiv ***");
			b.print_status(cerr);
			b.print(cerr);			
			cmd_error("DIVISION by 0");
			return c;
		}

	return c;
}


