/* SCCS  @(#)nsl_num_4_sub_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_4_sub_library.h
//
/*
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const nsl_num_4<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const nsl_num_4<NslNumType,NslTypeId>&,const nsl_num_4<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const nsl_num_4<NslNumType,NslTypeId>&,const nsl_data&);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const nsl_data&,const nsl_num_4<NslNumType,NslTypeId>&);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const nsl_num_4<NslNumType,NslTypeId>&,const num_type);
template<class NslNumType, int NslTypeId>
extern	nsl_num_4<NslNumType,NslTypeId> 	operator-(const num_type,const nsl_num_4<NslNumType,NslTypeId>&);

*/
// num_4 subtruction

template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const nsl_num_4<NslNumType,NslTypeId>& a)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << " = - (num_4) ";
        cout << a.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
		for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = -a[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const nsl_num_4<NslNumType,NslTypeId>& a,const nsl_num_4<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	if (aimax != bimax || ajmax != bjmax || akmax != bkmax || almax != blmax)
	{
		cmd_error("*** nsl_num_4::operator- ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent num_4 sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const nsl_num_4<NslNumType,NslTypeId>& a,const num_type b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const num_type a, const nsl_num_4<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_type) " << a << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a - b[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const nsl_num_4<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (data) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> operator-(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_4<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (data) " << a.get_name() << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a.get_data() - b[i][j][k][l];

	return c;
}

// num_4 subtraction
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const nsl_num_4<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = -a[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const nsl_num_4<NslNumType,NslTypeId>& a,const nsl_num_4<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	if (aimax != bimax || ajmax != bjmax || akmax != bkmax || almax != blmax)
	{
		cmd_error("*** nsl_num_4::NSLsub ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent num_4 sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const nsl_num_4<NslNumType,NslTypeId>& a,const num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const num_type a, const nsl_num_4<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a - b[i][j][k][l];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const nsl_num_4<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4 c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_4<NslNumType,NslTypeId> NSLsub(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_4<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType,NslTypeId> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a.get_data() - b[i][j][k][l];

	return c;
}

