/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_mult_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_1<NslNumType,NslTypeId>_mult_library.h
//
/*
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator^(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator^(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator^(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator^(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator^(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);

extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const NslNumType&);
extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
*/

// vector pointwise multiplication

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_1<NslNumType,NslTypeId>& a,const NslDouble1& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (vector) " << a.get_name() << " ^ (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator^ ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_1<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (vector) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_1<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (vector) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_1<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (vector) " << a.get_name() << " ^ (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (NslNumType) " << a << " ^ (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (NslNumType) " << a << " ^ (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (NslNumType) " << a << " ^ (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (vector) " << a.get_name() << " ^ (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator^(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator^\n";
	cout << "// (data) " << a.get_name() << " ^ (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// vector pointwise multiplication

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmult(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::NSLmult ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmult(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmult(const NslNumType a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a * b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmult(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] * b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLmult(const nsl_num_0<NslNumType,NslTypeId>& a,const  nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() * b[i];

	return c;
}

// mult equal

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a[i] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a[i] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();
	int amax = a.get_imax();
	int bmax = b.get_imax();

	if (amax != bmax || bmax != outmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < outmax; i++)
		out[i] = a[i] * b[i];
}

// mat to vec

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& b,
	const nsl_num_0<NslNumType,NslTypeId>& a)
{
	int simax = out.get_imax();
	int sbimax = b.get_imax();
	int sbjmax = b.get_jmax();

	out = 0;

	if (out.get_vec_type() == 0) // ROW
	{
		if (simax != sbjmax)
		{
			cmd_error("NSLmult_equal: Inconsistent matrix sizes");
			out.print_status(cerr);
			b.print_status(cerr);
		}

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
			out[j] = out[j] + a.get_data()*b[i][j];
	}
	else // COL
	{
		if (simax != sbimax)
		{
			cmd_error("NSLmult_equal: Inconsistent matrix sizes");
			out.print_status(cerr);
			b.print_status(cerr);
		}

		for (int i = 0; i < sbimax; i++)
		    for (int j = 0; j < sbjmax; j++)
			out[i] = out[i] + a.get_data()*b[i][j];
	}
}
template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bmax = b.get_imax();

	if (aimax != bmax || bmax != outmax)
	{
		cmd_error("NSLmult_equal: Inconsistent matrix sizes");
		out.print_status(cerr);
		a.print_status(cerr);
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		out[i] = a[i][j] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a.get_data() * b[i];
}

// mult plus

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a[i] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a[i] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a[i] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a.get_data() * b[i];
}

// mult minus

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a[i] * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a[i] * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a[i] * b[i];
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a.get_data() * b;
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a.get_data() * b.get_data();
}

template<class NslNumType, int NslTypeId>
void NSLmult_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a.get_data() * b[i];
}


