/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_sigma_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_0<NslNumType,NslTypeId>_sigma_library.h       */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > 1.0)
		c = 1.0;
	else if (a > 0)
		c = a*a*(3.0-2.0*a);
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType x1,const NslNumType x2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
        nsl_num_0<NslNumType,NslTypeId> sigma = (a-x1)/(x2-x1);
	if (a > x2)
	    c = 1.0;
	else if (a > x1)
	    c = sigma*sigma*(3.0-2.0*sigma);
	else
	    c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
        nsl_num_0<NslNumType,NslTypeId> sigma = (a-x1)/(x2-x1);
	if (a > x2)
	    c = 1.0;
	else if (a > x1)
	    c = sigma*sigma*(3.0-2.0*sigma);
	else
	    c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const float x1,const float x2,const float y1,const float y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
    float sigma = (a.get_value()-x1)/(x2-x1);
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	else
	    c = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const double x1,const double x2,const double y1,const double y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
    double sigma = (a.get_value()-x1)/(x2-x1);
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	else
	    c = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const int x1,const int x2,const int y1,const int y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
    int sigma = (a.get_value()-x1)/(x2-x1);
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	else
	    c = y1;
	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsigma(const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
        nsl_num_0<NslNumType,NslTypeId> sigma = (a-x1)/(x2-x1);
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	else
	    c = y1;
	return c;
}
