/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_ramp_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_2<NslNumType,NslTypeId>_ramp_library.h                   */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,
	const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType,
	const NslNumType,const NslNumType);
*/
// if a > 0 then a else 0

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a) 
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > (NslNumType) 0)
			c[i][j] = a[i][j];
		else
			c[i][j] = 0;
	return c;
}

// if a > b then a - b else 0

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j] - b[i][j];
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b.get_data();
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const float b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b;
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const double b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b;
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const int b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b;
		else
			c[i][j] = 0;
	return c;
}

// if a > b then a - b + y2 else y1

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b,const nsl_num_2<NslNumType,NslTypeId>& y1,
	const nsl_num_2<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax() ||
	    a.get_imax() != y1.get_imax() || a.get_jmax() != y1.get_jmax() ||
	    a.get_imax() != y2.get_imax() || a.get_jmax() != y2.get_jmax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("imax3: ",y1.get_imax());
		cmd_error("jmax3: ",y1.get_jmax());
		cmd_error("imax4: ",y2.get_imax());
		cmd_error("jmax4: ",y2.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j] - b[i][j] + y2[i][j];
		else
			c[i][j] = y1[i][j];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j] - b[i][j] + y2;
		else
			c[i][j] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_2<NslNumType,NslTypeId>& b,const nsl_num_0<NslNumType,NslTypeId>& y1,
	const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLramp ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b[i][j])
			c[i][j] = a[i][j] - b[i][j] + y2.get_data();
		else
			c[i][j] = y1.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const NslNumType b,const NslNumType y1,
	const NslNumType y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b + y2;
		else
			c[i][j] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLramp(const nsl_num_2<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b,const nsl_num_0<NslNumType,NslTypeId>& y1,
	const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > b)
			c[i][j] = a[i][j] - b.get_data() + y2.get_data();
		else
			c[i][j] = y1.get_data();
	return c;
}

