/* SCCS  @(#)nsl_num_2<NslNumType,NslTypeId>_sat_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_2<NslNumType,NslTypeId>_sat_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType,const NslNumType);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,
	const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&,
	const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>&,const NslNumType,
       const NslNumType,const NslNumType,const NslNumType);
*/

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > (NslNumType) 1)
			c[i][j] = (NslNumType) 1;
		else if (a[i][j] > 0)
			c[i][j] = a[i][j];
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& x1,const nsl_num_2<NslNumType,NslTypeId>& x2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != x1.get_imax() || a.get_jmax() != x1.get_jmax()||
	    a.get_imax() != x2.get_imax() || a.get_jmax() != x2.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("jmax2: ",x1.get_jmax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("jmax3: ",x2.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2[i][j])
		    c[i][j] = 1.0;
		else if (a[i][j] > x1[i][j])
		    c[i][j] = (a[i][j]-x1[i][j])/(x2[i][j]-x1[i][j]);
		else
		    c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const NslNumType x1,const NslNumType x2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2)
			c[i][j] = 1.0;
		else if (a[i][j] > x1)
			c[i][j] = (a[i][j]-x1)/(x2-x1);
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2)
			c[i][j] = 1.0;
		else if (a[i][j] > x1)
		   c[i][j] = 
			(a[i][j]-x1.get_data())/(x2.get_data()-x1.get_data());
		else
			c[i][j] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& x1,const nsl_num_2<NslNumType,NslTypeId>& x2,
	const nsl_num_2<NslNumType,NslTypeId>& y1,const nsl_num_2<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != x1.get_imax() || a.get_jmax() != x1.get_jmax() ||
	    a.get_imax() != x2.get_imax() || a.get_jmax() != x2.get_jmax() ||
	    a.get_imax() != y1.get_imax() || a.get_jmax() != y1.get_jmax() ||
	    a.get_imax() != y2.get_imax() || a.get_jmax() != y2.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("jmax2: ",x1.get_jmax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("jmax3: ",x2.get_jmax());
		cmd_error("imax4: ",y1.get_imax());
		cmd_error("jmax4: ",y1.get_jmax());
		cmd_error("imax5: ",y2.get_imax());
		cmd_error("jmax5: ",y2.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2[i][j])
		    c[i][j] = y2[i][j];
		else if (a[i][j] > x1[i][j])
		    c[i][j] = (y2[i][j]-y1[i][j])*(a[i][j]-x1[i][j])/
				(x2[i][j]-x1[i][j]) + y1[i][j];
		else
		    c[i][j] = y1[i][j];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& x1,const nsl_num_2<NslNumType,NslTypeId>& x2,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != x1.get_imax() || a.get_jmax() != x1.get_jmax() ||
	    a.get_imax() != x2.get_imax() || a.get_jmax() != x2.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("jmax2: ",x1.get_jmax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("jmax3: ",x2.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2[i][j])
		    c[i][j] = y2;
		else if (a[i][j] > x1[i][j])
		    c[i][j] = (y2-y1)*(a[i][j]-x1[i][j])/
				(x2[i][j]-x1[i][j]) + y1;
		else
		    c[i][j] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_2<NslNumType,NslTypeId>& x1,const nsl_num_2<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	if (a.get_imax() != x1.get_imax() || a.get_jmax() != x1.get_jmax() ||
	    a.get_imax() != x2.get_imax() || a.get_jmax() != x2.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("jmax2: ",x1.get_jmax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("jmax3: ",x2.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2[i][j])
		    c[i][j] = y2.get_data();
		else if (a[i][j] > x1[i][j])
		    c[i][j] = (y2.get_data()-y1.get_data())*(a[i][j]-x1[i][j])/
				(x2[i][j]-x1[i][j]) + y1.get_data();
		else
		    c[i][j] = y1.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const NslNumType x1,const NslNumType x2,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2)
		    c[i][j] = y2;
		else if (a[i][j] > x1)
		    c[i][j] = (y2-y1)*(a[i][j]-x1)/(x2-x1) + y1;
		else
		    c[i][j] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> NSLsat(const nsl_num_2<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_num_2<NslNumType,NslTypeId> c(s1,s2);

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (a[i][j] > x2)
		    c[i][j] = y2.get_data();
		else if (a[i][j] > x1)
		    c[i][j] = (y2.get_data()-y1.get_data()) *(a[i][j]- 
		x1.get_data())/(x2.get_data() - x1.get_data()) + y1.get_data();
		else
		    c[i][j] = y1.get_data();
	return c;
}


