/* SCCS  @(#)nsl_vector_sigma_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*					nsl_vector_sigma_library.h					*/
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
	   if (a[i] > 1.0)
		c[i] = 1.0;
	   else if (a[i] > 0)
		c[i] = a[i]*a[i]*(3.0-2.0*a[i]);
	   else
		c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& x1,
	const nsl_num_1<NslNumType,NslTypeId>& x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1[i])/(x2[i]-x1[i]);
	    if (a[i] > x2[i])
		    c[i] = 1.0;
	    else if (a[i] > x1[i])
		    c[i] = sigma*sigma*(3.0-2.0*sigma);
	    else
		    c[i] = 0;
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType x1,const NslNumType x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1)/(x2-x1);
	    if (a[i] > x2)
		    c[i] = 1.0;
	    else if (a[i] > x1)
		    c[i] = sigma*sigma*(3.0-2.0*sigma);
	    else
		    c[i] = 0;
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
 	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1.get_data())/(x2.get_data()-x1.get_data());
	    if (a[i] > x2)
		    c[i] = 1.0;
	    else if (a[i] > x1)
		    c[i] = sigma*sigma*(3.0-2.0*sigma);
	    else
		    c[i] = 0;
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& x1,
	const nsl_num_1<NslNumType,NslTypeId>& x2,const nsl_num_1<NslNumType,NslTypeId>& y1,const nsl_num_1<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1[i])/(x2[i]-x1[i]);
	    if (a[i] > x2[i])
		    c[i] = y2[i];
	    else if (a[i] > x1[i])
		    c[i] = (y2[i]-y1[i])*sigma*sigma*(3.0-2.0*sigma)
			 + y1[i];
	    else
		    c[i] = y1[i];
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& x1,
	const nsl_num_1<NslNumType,NslTypeId>& x2,const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1[i])/(x2[i]-x1[i]);
	    if (a[i] > x2[i])
		    c[i] = y2;
	    else if (a[i] > x1[i])
		    c[i] = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	    else
		    c[i] = y1;
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& x1,
	const nsl_num_1<NslNumType,NslTypeId>& x2,const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1[i])/(x2[i]-x1[i]);
	    if (a[i] > x2[i])
		    c[i] = y2.get_data();
	    else if (a[i] > x1[i])
		    c[i] = (y2.get_data()-y1.get_data())*sigma*sigma*(3.0-2.0*sigma) + y1.get_data();
	    else
		    c[i] = y1.get_data();
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType x1,const NslNumType x2,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1)/(x2-x1);
	    if (a[i] > x2)
		    c[i] = y2;
	    else if (a[i] > x1)
		    c[i] = (y2-y1)*sigma*sigma*(3.0-2.0*sigma) + y1;
	    else
		    c[i] = y1;
	}
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsigma(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);
	NslNumType sigma;

	for (int i = 0; i < s1; i++)
	{
            sigma = (a[i]-x1.get_data())/(x2.get_data()-x1.get_data());
	    if (a[i] > x2)
		    c[i] = y2.get_data();
	    else if (a[i] > x1)
		    c[i] = (y2.get_data()-y1.get_data())*sigma*sigma*(3.0-2.0*sigma) + y1.get_data();
	    else
		    c[i] = y1.get_data();
	}
	return c;
}
