/*
 * tkIntXlibDecls.h --
 *
 *	This file contains the declarations for all platform dependent
 *	unsupported functions that are exported by the Tk library.  These
 *	interfaces are not guaranteed to remain the same between
 *	versions.  Use at your own risk.
 *
 * Copyright (c) 1998-1999 by Scriptics Corporation.
 * All rights reserved.
 *
 * RCS: @(#) $Id: tkIntXlibDecls.h,v 1.11 1999/07/31 03:36:49 hobbs Exp $
 */

#ifndef _TKINTXLIBDECLS
#define _TKINTXLIBDECLS

#ifdef MAC_TCL
#include "Xutil.h"
#else
#include "X11/Xutil.h"
#endif

#ifdef BUILD_tk
#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLEXPORT
#endif

/*
 * WARNING: This file is automatically generated by the tools/genStubs.tcl
 * script.  Any modifications to the function declarations below should be made
 * in the generic/tkInt.decls script.
 */

/* !BEGIN!: Do not edit below this line. */

/*
 * Exported function declarations:
 */

#ifdef WIN32 // __WIN32__
/* Slot 0 is reserved */
/* 1 */
extern XModifierKeymap*	 XGetModifierMapping (Display* d);
/* 2 */
extern XImage *		XCreateImage (Display* d, Visual* v, 
				unsigned int ui1, int i1, int i2, char* cp, 
				unsigned int ui2, unsigned int ui3, int i3, 
				int i4);
/* 3 */
extern XImage *		XGetImage (Display* d, Drawable dr, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, unsigned long ul, int i3);
/* 4 */
extern char *		XGetAtomName (Display* d, Atom a);
/* 5 */
extern char *		XKeysymToString (KeySym k);
/* 6 */
extern Colormap		XCreateColormap (Display* d, Window w, 
				Visual* v, int i);
/* 7 */
extern Cursor		XCreatePixmapCursor (Display* d, 
				Pixmap p1, Pixmap p2, XColor* x1, XColor* x2, 
				unsigned int ui1, unsigned int ui2);
/* 8 */
extern Cursor		XCreateGlyphCursor (Display* d, Font f1, 
				Font f2, unsigned int ui1, unsigned int ui2, 
				XColor* x1, XColor* x2);
/* 9 */
extern GContext		XGContextFromGC (GC g);
/* 10 */
extern XHostAddress *	XListHosts (Display* d, int* i, Bool* b);
/* 11 */
extern KeySym		XKeycodeToKeysym (Display* d, 
				unsigned int k, int i);
/* 12 */
extern KeySym		XStringToKeysym (_Xconst char* c);
/* 13 */
extern Window		XRootWindow (Display* d, int i);
/* 14 */
extern XErrorHandler	XSetErrorHandler (XErrorHandler x);
/* 15 */
extern Status		XIconifyWindow (Display* d, Window w, 
				int i);
/* 16 */
extern Status		XWithdrawWindow (Display* d, Window w, 
				int i);
/* 17 */
extern Status		XGetWMColormapWindows (Display* d, 
				Window w, Window** wpp, int* ip);
/* 18 */
extern Status		XAllocColor (Display* d, Colormap c, 
				XColor* xp);
/* 19 */
extern void		XBell (Display* d, int i);
/* 20 */
extern void		XChangeProperty (Display* d, Window w, 
				Atom a1, Atom a2, int i1, int i2, 
				_Xconst unsigned char* c, int i3);
/* 21 */
extern void		XChangeWindowAttributes (Display* d, 
				Window w, unsigned long ul, 
				XSetWindowAttributes* x);
/* 22 */
extern void		XClearWindow (Display* d, Window w);
/* 23 */
extern void		XConfigureWindow (Display* d, Window w, 
				unsigned int i, XWindowChanges* x);
/* 24 */
extern void		XCopyArea (Display* d, Drawable dr1, 
				Drawable dr2, GC g, int i1, int i2, 
				unsigned int ui1, unsigned int ui2, int i3, 
				int i4);
/* 25 */
extern void		XCopyPlane (Display* d, Drawable dr1, 
				Drawable dr2, GC g, int i1, int i2, 
				unsigned int ui1, unsigned int ui2, int i3, 
				int i4, unsigned long ul);
/* 26 */
extern Pixmap		XCreateBitmapFromData (Display* display, 
				Drawable d, _Xconst char* data, 
				unsigned int width, unsigned int height);
/* 27 */
extern void		XDefineCursor (Display* d, Window w, 
				Cursor c);
/* 28 */
extern void		XDeleteProperty (Display* d, Window w, 
				Atom a);
/* 29 */
extern void		XDestroyWindow (Display* d, Window w);
/* 30 */
extern void		XDrawArc (Display* d, Drawable dr, GC g, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4);
/* 31 */
extern void		XDrawLines (Display* d, Drawable dr, 
				GC g, XPoint* x, int i1, int i2);
/* 32 */
extern void		XDrawRectangle (Display* d, Drawable dr, 
				GC g, int i1, int i2, unsigned int ui1, 
				unsigned int ui2);
/* 33 */
extern void		XFillArc (Display* d, Drawable dr, GC g, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4);
/* 34 */
extern void		XFillPolygon (Display* d, Drawable dr, 
				GC g, XPoint* x, int i1, int i2, int i3);
/* 35 */
extern void		XFillRectangles (Display* d, Drawable dr, 
				GC g, XRectangle* x, int i);
/* 36 */
extern void		XForceScreenSaver (Display* d, int i);
/* 37 */
extern void		XFreeColormap (Display* d, Colormap c);
/* 38 */
extern void		XFreeColors (Display* d, Colormap c, 
				unsigned long* ulp, int i, unsigned long ul);
/* 39 */
extern void		XFreeCursor (Display* d, Cursor c);
/* 40 */
extern void		XFreeModifiermap (XModifierKeymap* x);
/* 41 */
extern Status		XGetGeometry (Display* d, Drawable dr, 
				Window* w, int* i1, int* i2, 
				unsigned int* ui1, unsigned int* ui2, 
				unsigned int* ui3, unsigned int* ui4);
/* 42 */
extern void		XGetInputFocus (Display* d, Window* w, 
				int* i);
/* 43 */
extern int		XGetWindowProperty (Display* d, Window w, 
				Atom a1, long l1, long l2, Bool b, Atom a2, 
				Atom* ap, int* ip, unsigned long* ulp1, 
				unsigned long* ulp2, unsigned char** cpp);
/* 44 */
extern Status		XGetWindowAttributes (Display* d, 
				Window w, XWindowAttributes* x);
/* 45 */
extern int		XGrabKeyboard (Display* d, Window w, 
				Bool b, int i1, int i2, Time t);
/* 46 */
extern int		XGrabPointer (Display* d, Window w1, 
				Bool b, unsigned int ui, int i1, int i2, 
				Window w2, Cursor c, Time t);
/* 47 */
extern KeyCode		XKeysymToKeycode (Display* d, KeySym k);
/* 48 */
extern Status		XLookupColor (Display* d, Colormap c1, 
				_Xconst char* c2, XColor* x1, XColor* x2);
/* 49 */
extern void		XMapWindow (Display* d, Window w);
/* 50 */
extern void		XMoveResizeWindow (Display* d, Window w, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2);
/* 51 */
extern void		XMoveWindow (Display* d, Window w, 
				int i1, int i2);
/* 52 */
extern void		XNextEvent (Display* d, XEvent* x);
/* 53 */
extern void		XPutBackEvent (Display* d, XEvent* x);
/* 54 */
extern void		XQueryColors (Display* d, Colormap c, 
				XColor* x, int i);
/* 55 */
extern Bool		XQueryPointer (Display* d, Window w1, 
				Window* w2, Window* w3, int* i1, int* i2, 
				int* i3, int* i4, unsigned int* ui);
/* 56 */
extern Status		XQueryTree (Display* d, Window w1, 
				Window* w2, Window* w3, Window** w4, 
				unsigned int* ui);
/* 57 */
extern void		XRaiseWindow (Display* d, Window w);
/* 58 */
extern void		XRefreshKeyboardMapping (
				XMappingEvent* x);
/* 59 */
extern void		XResizeWindow (Display* d, Window w, 
				unsigned int ui1, unsigned int ui2);
/* 60 */
extern void		XSelectInput (Display* d, Window w, 
				long l);
/* 61 */
extern Status		XSendEvent (Display* d, Window w, Bool b, 
				long l, XEvent* x);
/* 62 */
extern void		XSetCommand (Display* d, Window w, 
				char** c, int i);
/* 63 */
extern void		XSetIconName (Display* d, Window w, 
				_Xconst char* c);
/* 64 */
extern void		XSetInputFocus (Display* d, Window w, 
				int i, Time t);
/* 65 */
extern void		XSetSelectionOwner (Display* d, Atom a, 
				Window w, Time t);
/* 66 */
extern void		XSetWindowBackground (Display* d, 
				Window w, unsigned long ul);
/* 67 */
extern void		XSetWindowBackgroundPixmap (Display* d, 
				Window w, Pixmap p);
/* 68 */
extern void		XSetWindowBorder (Display* d, Window w, 
				unsigned long ul);
/* 69 */
extern void		XSetWindowBorderPixmap (Display* d, 
				Window w, Pixmap p);
/* 70 */
extern void		XSetWindowBorderWidth (Display* d, 
				Window w, unsigned int ui);
/* 71 */
extern void		XSetWindowColormap (Display* d, Window w, 
				Colormap c);
/* 72 */
extern Bool		XTranslateCoordinates (Display* d, 
				Window w1, Window w2, int i1, int i2, 
				int* i3, int* i4, Window* w3);
/* 73 */
extern void		XUngrabKeyboard (Display* d, Time t);
/* 74 */
extern void		XUngrabPointer (Display* d, Time t);
/* 75 */
extern void		XUnmapWindow (Display* d, Window w);
/* 76 */
extern void		XWindowEvent (Display* d, Window w, 
				long l, XEvent* x);
/* 77 */
extern void		XDestroyIC (XIC x);
/* 78 */
extern Bool		XFilterEvent (XEvent* x, Window w);
/* 79 */
extern int		XmbLookupString (XIC xi, 
				XKeyPressedEvent* xk, char* c, int i, 
				KeySym* k, Status* s);
/* 80 */
extern void		TkPutImage (unsigned long * colors, 
				int ncolors, Display* display, Drawable d, 
				GC gc, XImage* image, int src_x, int src_y, 
				int dest_x, int dest_y, unsigned int width, 
				unsigned int height);
/* Slot 81 is reserved */
/* 82 */
extern Status		XParseColor (Display * display, 
				Colormap map, _Xconst char* spec, 
				XColor * colorPtr);
/* 83 */
extern GC		XCreateGC(Display* display, Drawable d, 
				unsigned long valuemask, XGCValues* values);
/* 84 */
extern void		XFreeGC(Display* display, GC gc);
/* 85 */
extern Atom		XInternAtom (Display* display, 
				_Xconst char* atom_name, Bool only_if_exists);
/* 86 */
extern void		XSetBackground (Display* display, GC gc, 
				unsigned long foreground);
/* 87 */
extern void		XSetForeground (Display* display, GC gc, 
				unsigned long foreground);
/* 88 */
extern void		XSetClipMask (Display* display, GC gc, 
				Pixmap pixmap);
/* 89 */
extern void		XSetClipOrigin (Display* display, GC gc, 
				int clip_x_origin, int clip_y_origin);
/* 90 */
extern void		XSetTSOrigin (Display* display, GC gc, 
				int ts_x_origin, int ts_y_origin);
/* 91 */
extern void		XChangeGC (Display * d, GC gc, 
				unsigned long mask, XGCValues * values);
/* 92 */
extern void		XSetFont (Display * display, GC gc, 
				Font font);
/* 93 */
extern void		XSetArcMode (Display * display, GC gc, 
				int arc_mode);
/* 94 */
extern void		XSetStipple (Display * display, GC gc, 
				Pixmap stipple);
/* 95 */
extern void		XSetFillRule (Display * display, GC gc, 
				int fill_rule);
/* 96 */
extern void		XSetFillStyle (Display * display, GC gc, 
				int fill_style);
/* 97 */
extern void		XSetFunction (Display * display, GC gc, 
				int function);
/* 98 */
extern void		XSetLineAttributes (Display * display, 
				GC gc, unsigned int line_width, 
				int line_style, int cap_style, 
				int join_style);
/* 99 */
extern int		_XInitImageFuncPtrs (XImage * image);
/* 100 */
extern XIC		XCreateIC (void);
/* 101 */
extern XVisualInfo *	XGetVisualInfo (Display* display, 
				long vinfo_mask, XVisualInfo* vinfo_template, 
				int* nitems_return);
/* 102 */
extern void		XSetWMClientMachine (Display* display, 
				Window w, XTextProperty* text_prop);
/* 103 */
extern Status		XStringListToTextProperty (char** list, 
				int count, XTextProperty* text_prop_return);
/* 104 */
extern void		XDrawLine (Display* d, Drawable dr, GC g, 
				int x1, int y1, int x2, int y2);
/* Slot 105 is reserved */
/* 106 */
extern void		XFillRectangle (Display* display, 
				Drawable d, GC gc, int x, int y, 
				unsigned int width, unsigned int height);
#endif /* __WIN32__ */
#ifdef MAC_TCL
/* Slot 0 is reserved */
/* 1 */
extern XModifierKeymap*	 XGetModifierMapping (Display* d);
/* 2 */
extern XImage *		XCreateImage (Display* d, Visual* v, 
				unsigned int ui1, int i1, int i2, char* cp, 
				unsigned int ui2, unsigned int ui3, int i3, 
				int i4);
/* 3 */
extern XImage *		XGetImage (Display* d, Drawable dr, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, unsigned long ul, int i3);
/* 4 */
extern char *		XGetAtomName (Display* d, Atom a);
/* 5 */
extern char *		XKeysymToString (KeySym k);
/* 6 */
extern Colormap		XCreateColormap (Display* d, Window w, 
				Visual* v, int i);
/* 7 */
extern GContext		XGContextFromGC (GC g);
/* 8 */
extern KeySym		XKeycodeToKeysym (Display* d, KeyCode k, 
				int i);
/* 9 */
extern KeySym		XStringToKeysym (_Xconst char* c);
/* 10 */
extern Window		XRootWindow (Display* d, int i);
/* 11 */
extern XErrorHandler	XSetErrorHandler (XErrorHandler x);
/* 12 */
extern Status		XAllocColor (Display* d, Colormap c, 
				XColor* xp);
/* 13 */
extern void		XBell (Display* d, int i);
/* 14 */
extern void		XChangeProperty (Display* d, Window w, 
				Atom a1, Atom a2, int i1, int i2, 
				_Xconst unsigned char* c, int i3);
/* 15 */
extern void		XChangeWindowAttributes (Display* d, 
				Window w, unsigned long ul, 
				XSetWindowAttributes* x);
/* 16 */
extern void		XConfigureWindow (Display* d, Window w, 
				unsigned int i, XWindowChanges* x);
/* 17 */
extern void		XCopyArea (Display* d, Drawable dr1, 
				Drawable dr2, GC g, int i1, int i2, 
				unsigned int ui1, unsigned int ui2, int i3, 
				int i4);
/* 18 */
extern void		XCopyPlane (Display* d, Drawable dr1, 
				Drawable dr2, GC g, int i1, int i2, 
				unsigned int ui1, unsigned int ui2, int i3, 
				int i4, unsigned long ul);
/* 19 */
extern Pixmap		XCreateBitmapFromData (Display* display, 
				Drawable d, _Xconst char* data, 
				unsigned int width, unsigned int height);
/* 20 */
extern void		XDefineCursor (Display* d, Window w, 
				Cursor c);
/* 21 */
extern void		XDestroyWindow (Display* d, Window w);
/* 22 */
extern void		XDrawArc (Display* d, Drawable dr, GC g, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4);
/* 23 */
extern void		XDrawLines (Display* d, Drawable dr, 
				GC g, XPoint* x, int i1, int i2);
/* 24 */
extern void		XDrawRectangle (Display* d, Drawable dr, 
				GC g, int i1, int i2, unsigned int ui1, 
				unsigned int ui2);
/* 25 */
extern void		XFillArc (Display* d, Drawable dr, GC g, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2, int i3, int i4);
/* 26 */
extern void		XFillPolygon (Display* d, Drawable dr, 
				GC g, XPoint* x, int i1, int i2, int i3);
/* 27 */
extern void		XFillRectangles (Display* d, Drawable dr, 
				GC g, XRectangle* x, int i);
/* 28 */
extern void		XFreeColormap (Display* d, Colormap c);
/* 29 */
extern void		XFreeColors (Display* d, Colormap c, 
				unsigned long* ulp, int i, unsigned long ul);
/* 30 */
extern void		XFreeModifiermap (XModifierKeymap* x);
/* 31 */
extern Status		XGetGeometry (Display* d, Drawable dr, 
				Window* w, int* i1, int* i2, 
				unsigned int* ui1, unsigned int* ui2, 
				unsigned int* ui3, unsigned int* ui4);
/* 32 */
extern int		XGetWindowProperty (Display* d, Window w, 
				Atom a1, long l1, long l2, Bool b, Atom a2, 
				Atom* ap, int* ip, unsigned long* ulp1, 
				unsigned long* ulp2, unsigned char** cpp);
/* 33 */
extern int		XGrabKeyboard (Display* d, Window w, 
				Bool b, int i1, int i2, Time t);
/* 34 */
extern int		XGrabPointer (Display* d, Window w1, 
				Bool b, unsigned int ui, int i1, int i2, 
				Window w2, Cursor c, Time t);
/* 35 */
extern KeyCode		XKeysymToKeycode (Display* d, KeySym k);
/* 36 */
extern void		XMapWindow (Display* d, Window w);
/* 37 */
extern void		XMoveResizeWindow (Display* d, Window w, 
				int i1, int i2, unsigned int ui1, 
				unsigned int ui2);
/* 38 */
extern void		XMoveWindow (Display* d, Window w, 
				int i1, int i2);
/* 39 */
extern Bool		XQueryPointer (Display* d, Window w1, 
				Window* w2, Window* w3, int* i1, int* i2, 
				int* i3, int* i4, unsigned int* ui);
/* 40 */
extern void		XRaiseWindow (Display* d, Window w);
/* 41 */
extern void		XRefreshKeyboardMapping (
				XMappingEvent* x);
/* 42 */
extern void		XResizeWindow (Display* d, Window w, 
				unsigned int ui1, unsigned int ui2);
/* 43 */
extern void		XSelectInput (Display* d, Window w, 
				long l);
/* 44 */
extern Status		XSendEvent (Display* d, Window w, Bool b, 
				long l, XEvent* x);
/* 45 */
extern void		XSetIconName (Display* d, Window w, 
				_Xconst char* c);
/* 46 */
extern void		XSetInputFocus (Display* d, Window w, 
				int i, Time t);
/* 47 */
extern void		XSetSelectionOwner (Display* d, Atom a, 
				Window w, Time t);
/* 48 */
extern void		XSetWindowBackground (Display* d, 
				Window w, unsigned long ul);
/* 49 */
extern void		XSetWindowBackgroundPixmap (Display* d, 
				Window w, Pixmap p);
/* 50 */
extern void		XSetWindowBorder (Display* d, Window w, 
				unsigned long ul);
/* 51 */
extern void		XSetWindowBorderPixmap (Display* d, 
				Window w, Pixmap p);
/* 52 */
extern void		XSetWindowBorderWidth (Display* d, 
				Window w, unsigned int ui);
/* 53 */
extern void		XSetWindowColormap (Display* d, Window w, 
				Colormap c);
/* 54 */
extern void		XUngrabKeyboard (Display* d, Time t);
/* 55 */
extern void		XUngrabPointer (Display* d, Time t);
/* 56 */
extern void		XUnmapWindow (Display* d, Window w);
/* 57 */
extern void		TkPutImage (unsigned long * colors, 
				int ncolors, Display* display, Drawable d, 
				GC gc, XImage* image, int src_x, int src_y, 
				int dest_x, int dest_y, unsigned int width, 
				unsigned int height);
/* 58 */
extern Status		XParseColor (Display * display, 
				Colormap map, _Xconst char* spec, 
				XColor * colorPtr);
/* 59 */
extern GC		XCreateGC (Display* display, Drawable d, 
				unsigned long valuemask, XGCValues* values);
/* 60 */
extern void		XFreeGC (Display* display, GC gc);
/* 61 */
extern Atom		XInternAtom (Display* display, 
				_Xconst char* atom_name, Bool only_if_exists);
/* 62 */
extern void		XSetBackground (Display* display, GC gc, 
				unsigned long foreground);
/* 63 */
extern void		XSetForeground (Display* display, GC gc, 
				unsigned long foreground);
/* 64 */
extern void		XSetClipMask (Display* display, GC gc, 
				Pixmap pixmap);
/* 65 */
extern void		XSetClipOrigin (Display* display, GC gc, 
				int clip_x_origin, int clip_y_origin);
/* 66 */
extern void		XSetTSOrigin (Display* display, GC gc, 
				int ts_x_origin, int ts_y_origin);
/* 67 */
extern void		XChangeGC (Display * d, GC gc, 
				unsigned long mask, XGCValues * values);
/* 68 */
extern void		XSetFont (Display * display, GC gc, 
				Font font);
/* 69 */
extern void		XSetArcMode (Display * display, GC gc, 
				int arc_mode);
/* 70 */
extern void		XSetStipple (Display * display, GC gc, 
				Pixmap stipple);
/* 71 */
extern void		XSetFillRule (Display * display, GC gc, 
				int fill_rule);
/* 72 */
extern void		XSetFillStyle (Display * display, GC gc, 
				int fill_style);
/* 73 */
extern void		XSetFunction (Display * display, GC gc, 
				int function);
/* 74 */
extern void		XSetLineAttributes (Display * display, 
				GC gc, unsigned int line_width, 
				int line_style, int cap_style, 
				int join_style);
/* 75 */
extern int		_XInitImageFuncPtrs (XImage * image);
/* 76 */
extern XIC		XCreateIC (void);
/* 77 */
extern XVisualInfo *	XGetVisualInfo (Display* display, 
				long vinfo_mask, XVisualInfo* vinfo_template, 
				int* nitems_return);
/* 78 */
extern void		XSetWMClientMachine (Display* display, 
				Window w, XTextProperty* text_prop);
/* 79 */
extern Status		XStringListToTextProperty (char** list, 
				int count, XTextProperty* text_prop_return);
/* 80 */
extern void		XDrawSegments (Display * display, 
				Drawable d, GC gc, XSegment * segments, 
				int nsegments);
/* 81 */
extern void		XForceScreenSaver (Display* display, 
				int mode);
/* 82 */
extern void		XDrawLine (Display* d, Drawable dr, GC g, 
				int x1, int y1, int x2, int y2);
/* 83 */
extern void		XFillRectangle (Display* display, 
				Drawable d, GC gc, int x, int y, 
				unsigned int width, unsigned int height);
#endif /* MAC_TCL */

typedef struct TkIntXlibStubs {
    int magic;
    struct TkIntXlibStubHooks *hooks;

#ifdef __WIN32__
    void *reserved0;
    XModifierKeymap* (*xGetModifierMapping) (Display* d); /* 1 */
    XImage * (*xCreateImage) (Display* d, Visual* v, unsigned int ui1, int i1, int i2, char* cp, unsigned int ui2, unsigned int ui3, int i3, int i4); /* 2 */
    XImage * (*xGetImage) (Display* d, Drawable dr, int i1, int i2, unsigned int ui1, unsigned int ui2, unsigned long ul, int i3); /* 3 */
    char * (*xGetAtomName) (Display* d, Atom a); /* 4 */
    char * (*xKeysymToString) (KeySym k); /* 5 */
    Colormap (*xCreateColormap) (Display* d, Window w, Visual* v, int i); /* 6 */
    Cursor (*xCreatePixmapCursor) (Display* d, Pixmap p1, Pixmap p2, XColor* x1, XColor* x2, unsigned int ui1, unsigned int ui2); /* 7 */
    Cursor (*xCreateGlyphCursor) (Display* d, Font f1, Font f2, unsigned int ui1, unsigned int ui2, XColor* x1, XColor* x2); /* 8 */
    GContext (*xGContextFromGC) (GC g); /* 9 */
    XHostAddress * (*xListHosts) (Display* d, int* i, Bool* b); /* 10 */
    KeySym (*xKeycodeToKeysym) (Display* d, unsigned int k, int i); /* 11 */
    KeySym (*xStringToKeysym) (_Xconst char* c); /* 12 */
    Window (*xRootWindow) (Display* d, int i); /* 13 */
    XErrorHandler (*xSetErrorHandler) (XErrorHandler x); /* 14 */
    Status (*xIconifyWindow) (Display* d, Window w, int i); /* 15 */
    Status (*xWithdrawWindow) (Display* d, Window w, int i); /* 16 */
    Status (*xGetWMColormapWindows) (Display* d, Window w, Window** wpp, int* ip); /* 17 */
    Status (*xAllocColor) (Display* d, Colormap c, XColor* xp); /* 18 */
    void (*xBell) (Display* d, int i); /* 19 */
    void (*xChangeProperty) (Display* d, Window w, Atom a1, Atom a2, int i1, int i2, _Xconst unsigned char* c, int i3); /* 20 */
    void (*xChangeWindowAttributes) (Display* d, Window w, unsigned long ul, XSetWindowAttributes* x); /* 21 */
    void (*xClearWindow) (Display* d, Window w); /* 22 */
    void (*xConfigureWindow) (Display* d, Window w, unsigned int i, XWindowChanges* x); /* 23 */
    void (*xCopyArea) (Display* d, Drawable dr1, Drawable dr2, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 24 */
    void (*xCopyPlane) (Display* d, Drawable dr1, Drawable dr2, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4, unsigned long ul); /* 25 */
    Pixmap (*xCreateBitmapFromData) (Display* display, Drawable d, _Xconst char* data, unsigned int width, unsigned int height); /* 26 */
    void (*xDefineCursor) (Display* d, Window w, Cursor c); /* 27 */
    void (*xDeleteProperty) (Display* d, Window w, Atom a); /* 28 */
    void (*xDestroyWindow) (Display* d, Window w); /* 29 */
    void (*xDrawArc) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 30 */
    void (*xDrawLines) (Display* d, Drawable dr, GC g, XPoint* x, int i1, int i2); /* 31 */
    void (*xDrawRectangle) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2); /* 32 */
    void (*xFillArc) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 33 */
    void (*xFillPolygon) (Display* d, Drawable dr, GC g, XPoint* x, int i1, int i2, int i3); /* 34 */
    void (*xFillRectangles) (Display* d, Drawable dr, GC g, XRectangle* x, int i); /* 35 */
    void (*xForceScreenSaver) (Display* d, int i); /* 36 */
    void (*xFreeColormap) (Display* d, Colormap c); /* 37 */
    void (*xFreeColors) (Display* d, Colormap c, unsigned long* ulp, int i, unsigned long ul); /* 38 */
    void (*xFreeCursor) (Display* d, Cursor c); /* 39 */
    void (*xFreeModifiermap) (XModifierKeymap* x); /* 40 */
    Status (*xGetGeometry) (Display* d, Drawable dr, Window* w, int* i1, int* i2, unsigned int* ui1, unsigned int* ui2, unsigned int* ui3, unsigned int* ui4); /* 41 */
    void (*xGetInputFocus) (Display* d, Window* w, int* i); /* 42 */
    int (*xGetWindowProperty) (Display* d, Window w, Atom a1, long l1, long l2, Bool b, Atom a2, Atom* ap, int* ip, unsigned long* ulp1, unsigned long* ulp2, unsigned char** cpp); /* 43 */
    Status (*xGetWindowAttributes) (Display* d, Window w, XWindowAttributes* x); /* 44 */
    int (*xGrabKeyboard) (Display* d, Window w, Bool b, int i1, int i2, Time t); /* 45 */
    int (*xGrabPointer) (Display* d, Window w1, Bool b, unsigned int ui, int i1, int i2, Window w2, Cursor c, Time t); /* 46 */
    KeyCode (*xKeysymToKeycode) (Display* d, KeySym k); /* 47 */
    Status (*xLookupColor) (Display* d, Colormap c1, _Xconst char* c2, XColor* x1, XColor* x2); /* 48 */
    void (*xMapWindow) (Display* d, Window w); /* 49 */
    void (*xMoveResizeWindow) (Display* d, Window w, int i1, int i2, unsigned int ui1, unsigned int ui2); /* 50 */
    void (*xMoveWindow) (Display* d, Window w, int i1, int i2); /* 51 */
    void (*xNextEvent) (Display* d, XEvent* x); /* 52 */
    void (*xPutBackEvent) (Display* d, XEvent* x); /* 53 */
    void (*xQueryColors) (Display* d, Colormap c, XColor* x, int i); /* 54 */
    Bool (*xQueryPointer) (Display* d, Window w1, Window* w2, Window* w3, int* i1, int* i2, int* i3, int* i4, unsigned int* ui); /* 55 */
    Status (*xQueryTree) (Display* d, Window w1, Window* w2, Window* w3, Window** w4, unsigned int* ui); /* 56 */
    void (*xRaiseWindow) (Display* d, Window w); /* 57 */
    void (*xRefreshKeyboardMapping) (XMappingEvent* x); /* 58 */
    void (*xResizeWindow) (Display* d, Window w, unsigned int ui1, unsigned int ui2); /* 59 */
    void (*xSelectInput) (Display* d, Window w, long l); /* 60 */
    Status (*xSendEvent) (Display* d, Window w, Bool b, long l, XEvent* x); /* 61 */
    void (*xSetCommand) (Display* d, Window w, char** c, int i); /* 62 */
    void (*xSetIconName) (Display* d, Window w, _Xconst char* c); /* 63 */
    void (*xSetInputFocus) (Display* d, Window w, int i, Time t); /* 64 */
    void (*xSetSelectionOwner) (Display* d, Atom a, Window w, Time t); /* 65 */
    void (*xSetWindowBackground) (Display* d, Window w, unsigned long ul); /* 66 */
    void (*xSetWindowBackgroundPixmap) (Display* d, Window w, Pixmap p); /* 67 */
    void (*xSetWindowBorder) (Display* d, Window w, unsigned long ul); /* 68 */
    void (*xSetWindowBorderPixmap) (Display* d, Window w, Pixmap p); /* 69 */
    void (*xSetWindowBorderWidth) (Display* d, Window w, unsigned int ui); /* 70 */
    void (*xSetWindowColormap) (Display* d, Window w, Colormap c); /* 71 */
    Bool (*xTranslateCoordinates) (Display* d, Window w1, Window w2, int i1, int i2, int* i3, int* i4, Window* w3); /* 72 */
    void (*xUngrabKeyboard) (Display* d, Time t); /* 73 */
    void (*xUngrabPointer) (Display* d, Time t); /* 74 */
    void (*xUnmapWindow) (Display* d, Window w); /* 75 */
    void (*xWindowEvent) (Display* d, Window w, long l, XEvent* x); /* 76 */
    void (*xDestroyIC) (XIC x); /* 77 */
    Bool (*xFilterEvent) (XEvent* x, Window w); /* 78 */
    int (*xmbLookupString) (XIC xi, XKeyPressedEvent* xk, char* c, int i, KeySym* k, Status* s); /* 79 */
    void (*tkPutImage) (unsigned long * colors, int ncolors, Display* display, Drawable d, GC gc, XImage* image, int src_x, int src_y, int dest_x, int dest_y, unsigned int width, unsigned int height); /* 80 */
    void *reserved81;
    Status (*xParseColor) (Display * display, Colormap map, _Xconst char* spec, XColor * colorPtr); /* 82 */
    GC (*xCreateGC) (Display* display, Drawable d, unsigned long valuemask, XGCValues* values); /* 83 */
    void (*xFreeGC) (Display* display, GC gc); /* 84 */
    Atom (*xInternAtom) (Display* display, _Xconst char* atom_name, Bool only_if_exists); /* 85 */
    void (*xSetBackground) (Display* display, GC gc, unsigned long foreground); /* 86 */
    void (*xSetForeground) (Display* display, GC gc, unsigned long foreground); /* 87 */
    void (*xSetClipMask) (Display* display, GC gc, Pixmap pixmap); /* 88 */
    void (*xSetClipOrigin) (Display* display, GC gc, int clip_x_origin, int clip_y_origin); /* 89 */
    void (*xSetTSOrigin) (Display* display, GC gc, int ts_x_origin, int ts_y_origin); /* 90 */
    void (*xChangeGC) (Display * d, GC gc, unsigned long mask, XGCValues * values); /* 91 */
    void (*xSetFont) (Display * display, GC gc, Font font); /* 92 */
    void (*xSetArcMode) (Display * display, GC gc, int arc_mode); /* 93 */
    void (*xSetStipple) (Display * display, GC gc, Pixmap stipple); /* 94 */
    void (*xSetFillRule) (Display * display, GC gc, int fill_rule); /* 95 */
    void (*xSetFillStyle) (Display * display, GC gc, int fill_style); /* 96 */
    void (*xSetFunction) (Display * display, GC gc, int function); /* 97 */
    void (*xSetLineAttributes) (Display * display, GC gc, unsigned int line_width, int line_style, int cap_style, int join_style); /* 98 */
    int (*_XInitImageFuncPtrs) (XImage * image); /* 99 */
    XIC (*xCreateIC) (void); /* 100 */
    XVisualInfo * (*xGetVisualInfo) (Display* display, long vinfo_mask, XVisualInfo* vinfo_template, int* nitems_return); /* 101 */
    void (*xSetWMClientMachine) (Display* display, Window w, XTextProperty* text_prop); /* 102 */
    Status (*xStringListToTextProperty) (char** list, int count, XTextProperty* text_prop_return); /* 103 */
    void (*xDrawLine) (Display* d, Drawable dr, GC g, int x1, int y1, int x2, int y2); /* 104 */
    void *reserved105;
    void (*xFillRectangle) (Display* display, Drawable d, GC gc, int x, int y, unsigned int width, unsigned int height); /* 106 */
#endif /* __WIN32__ */
#ifdef MAC_TCL
    void *reserved0;
    XModifierKeymap* (*xGetModifierMapping) (Display* d); /* 1 */
    XImage * (*xCreateImage) (Display* d, Visual* v, unsigned int ui1, int i1, int i2, char* cp, unsigned int ui2, unsigned int ui3, int i3, int i4); /* 2 */
    XImage * (*xGetImage) (Display* d, Drawable dr, int i1, int i2, unsigned int ui1, unsigned int ui2, unsigned long ul, int i3); /* 3 */
    char * (*xGetAtomName) (Display* d, Atom a); /* 4 */
    char * (*xKeysymToString) (KeySym k); /* 5 */
    Colormap (*xCreateColormap) (Display* d, Window w, Visual* v, int i); /* 6 */
    GContext (*xGContextFromGC) (GC g); /* 7 */
    KeySym (*xKeycodeToKeysym) (Display* d, KeyCode k, int i); /* 8 */
    KeySym (*xStringToKeysym) (_Xconst char* c); /* 9 */
    Window (*xRootWindow) (Display* d, int i); /* 10 */
    XErrorHandler (*xSetErrorHandler) (XErrorHandler x); /* 11 */
    Status (*xAllocColor) (Display* d, Colormap c, XColor* xp); /* 12 */
    void (*xBell) (Display* d, int i); /* 13 */
    void (*xChangeProperty) (Display* d, Window w, Atom a1, Atom a2, int i1, int i2, _Xconst unsigned char* c, int i3); /* 14 */
    void (*xChangeWindowAttributes) (Display* d, Window w, unsigned long ul, XSetWindowAttributes* x); /* 15 */
    void (*xConfigureWindow) (Display* d, Window w, unsigned int i, XWindowChanges* x); /* 16 */
    void (*xCopyArea) (Display* d, Drawable dr1, Drawable dr2, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 17 */
    void (*xCopyPlane) (Display* d, Drawable dr1, Drawable dr2, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4, unsigned long ul); /* 18 */
    Pixmap (*xCreateBitmapFromData) (Display* display, Drawable d, _Xconst char* data, unsigned int width, unsigned int height); /* 19 */
    void (*xDefineCursor) (Display* d, Window w, Cursor c); /* 20 */
    void (*xDestroyWindow) (Display* d, Window w); /* 21 */
    void (*xDrawArc) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 22 */
    void (*xDrawLines) (Display* d, Drawable dr, GC g, XPoint* x, int i1, int i2); /* 23 */
    void (*xDrawRectangle) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2); /* 24 */
    void (*xFillArc) (Display* d, Drawable dr, GC g, int i1, int i2, unsigned int ui1, unsigned int ui2, int i3, int i4); /* 25 */
    void (*xFillPolygon) (Display* d, Drawable dr, GC g, XPoint* x, int i1, int i2, int i3); /* 26 */
    void (*xFillRectangles) (Display* d, Drawable dr, GC g, XRectangle* x, int i); /* 27 */
    void (*xFreeColormap) (Display* d, Colormap c); /* 28 */
    void (*xFreeColors) (Display* d, Colormap c, unsigned long* ulp, int i, unsigned long ul); /* 29 */
    void (*xFreeModifiermap) (XModifierKeymap* x); /* 30 */
    Status (*xGetGeometry) (Display* d, Drawable dr, Window* w, int* i1, int* i2, unsigned int* ui1, unsigned int* ui2, unsigned int* ui3, unsigned int* ui4); /* 31 */
    int (*xGetWindowProperty) (Display* d, Window w, Atom a1, long l1, long l2, Bool b, Atom a2, Atom* ap, int* ip, unsigned long* ulp1, unsigned long* ulp2, unsigned char** cpp); /* 32 */
    int (*xGrabKeyboard) (Display* d, Window w, Bool b, int i1, int i2, Time t); /* 33 */
    int (*xGrabPointer) (Display* d, Window w1, Bool b, unsigned int ui, int i1, int i2, Window w2, Cursor c, Time t); /* 34 */
    KeyCode (*xKeysymToKeycode) (Display* d, KeySym k); /* 35 */
    void (*xMapWindow) (Display* d, Window w); /* 36 */
    void (*xMoveResizeWindow) (Display* d, Window w, int i1, int i2, unsigned int ui1, unsigned int ui2); /* 37 */
    void (*xMoveWindow) (Display* d, Window w, int i1, int i2); /* 38 */
    Bool (*xQueryPointer) (Display* d, Window w1, Window* w2, Window* w3, int* i1, int* i2, int* i3, int* i4, unsigned int* ui); /* 39 */
    void (*xRaiseWindow) (Display* d, Window w); /* 40 */
    void (*xRefreshKeyboardMapping) (XMappingEvent* x); /* 41 */
    void (*xResizeWindow) (Display* d, Window w, unsigned int ui1, unsigned int ui2); /* 42 */
    void (*xSelectInput) (Display* d, Window w, long l); /* 43 */
    Status (*xSendEvent) (Display* d, Window w, Bool b, long l, XEvent* x); /* 44 */
    void (*xSetIconName) (Display* d, Window w, _Xconst char* c); /* 45 */
    void (*xSetInputFocus) (Display* d, Window w, int i, Time t); /* 46 */
    void (*xSetSelectionOwner) (Display* d, Atom a, Window w, Time t); /* 47 */
    void (*xSetWindowBackground) (Display* d, Window w, unsigned long ul); /* 48 */
    void (*xSetWindowBackgroundPixmap) (Display* d, Window w, Pixmap p); /* 49 */
    void (*xSetWindowBorder) (Display* d, Window w, unsigned long ul); /* 50 */
    void (*xSetWindowBorderPixmap) (Display* d, Window w, Pixmap p); /* 51 */
    void (*xSetWindowBorderWidth) (Display* d, Window w, unsigned int ui); /* 52 */
    void (*xSetWindowColormap) (Display* d, Window w, Colormap c); /* 53 */
    void (*xUngrabKeyboard) (Display* d, Time t); /* 54 */
    void (*xUngrabPointer) (Display* d, Time t); /* 55 */
    void (*xUnmapWindow) (Display* d, Window w); /* 56 */
    void (*tkPutImage) (unsigned long * colors, int ncolors, Display* display, Drawable d, GC gc, XImage* image, int src_x, int src_y, int dest_x, int dest_y, unsigned int width, unsigned int height); /* 57 */
    Status (*xParseColor) (Display * display, Colormap map, _Xconst char* spec, XColor * colorPtr); /* 58 */
    GC (*xCreateGC) (Display* display, Drawable d, unsigned long valuemask, XGCValues* values); /* 59 */
    void (*xFreeGC) (Display* display, GC gc); /* 60 */
    Atom (*xInternAtom) (Display* display, _Xconst char* atom_name, Bool only_if_exists); /* 61 */
    void (*xSetBackground) (Display* display, GC gc, unsigned long foreground); /* 62 */
    void (*xSetForeground) (Display* display, GC gc, unsigned long foreground); /* 63 */
    void (*xSetClipMask) (Display* display, GC gc, Pixmap pixmap); /* 64 */
    void (*xSetClipOrigin) (Display* display, GC gc, int clip_x_origin, int clip_y_origin); /* 65 */
    void (*xSetTSOrigin) (Display* display, GC gc, int ts_x_origin, int ts_y_origin); /* 66 */
    void (*xChangeGC) (Display * d, GC gc, unsigned long mask, XGCValues * values); /* 67 */
    void (*xSetFont) (Display * display, GC gc, Font font); /* 68 */
    void (*xSetArcMode) (Display * display, GC gc, int arc_mode); /* 69 */
    void (*xSetStipple) (Display * display, GC gc, Pixmap stipple); /* 70 */
    void (*xSetFillRule) (Display * display, GC gc, int fill_rule); /* 71 */
    void (*xSetFillStyle) (Display * display, GC gc, int fill_style); /* 72 */
    void (*xSetFunction) (Display * display, GC gc, int function); /* 73 */
    void (*xSetLineAttributes) (Display * display, GC gc, unsigned int line_width, int line_style, int cap_style, int join_style); /* 74 */
    int (*_XInitImageFuncPtrs) (XImage * image); /* 75 */
    XIC (*xCreateIC) (void); /* 76 */
    XVisualInfo * (*xGetVisualInfo) (Display* display, long vinfo_mask, XVisualInfo* vinfo_template, int* nitems_return); /* 77 */
    void (*xSetWMClientMachine) (Display* display, Window w, XTextProperty* text_prop); /* 78 */
    Status (*xStringListToTextProperty) (char** list, int count, XTextProperty* text_prop_return); /* 79 */
    void (*xDrawSegments) (Display * display, Drawable d, GC gc, XSegment * segments, int nsegments); /* 80 */
    void (*xForceScreenSaver) (Display* display, int mode); /* 81 */
    void (*xDrawLine) (Display* d, Drawable dr, GC g, int x1, int y1, int x2, int y2); /* 82 */
    void (*xFillRectangle) (Display* display, Drawable d, GC gc, int x, int y, unsigned int width, unsigned int height); /* 83 */
#endif /* MAC_TCL */
} TkIntXlibStubs;

#ifdef __cplusplus
extern "C" {
#endif
extern TkIntXlibStubs *tkIntXlibStubsPtr;
#ifdef __cplusplus
}
#endif

#if defined(USE_TK_STUBS) && !defined(USE_TK_STUB_PROCS)

/*
 * Inline function declarations:
 */

#ifdef __WIN32__
/* Slot 0 is reserved */
#ifndef XGetModifierMapping
#define XGetModifierMapping \
	(tkIntXlibStubsPtr->xGetModifierMapping) /* 1 */
#endif
#ifndef XCreateImage
#define XCreateImage \
	(tkIntXlibStubsPtr->xCreateImage) /* 2 */
#endif
#ifndef XGetImage
#define XGetImage \
	(tkIntXlibStubsPtr->xGetImage) /* 3 */
#endif
#ifndef XGetAtomName
#define XGetAtomName \
	(tkIntXlibStubsPtr->xGetAtomName) /* 4 */
#endif
#ifndef XKeysymToString
#define XKeysymToString \
	(tkIntXlibStubsPtr->xKeysymToString) /* 5 */
#endif
#ifndef XCreateColormap
#define XCreateColormap \
	(tkIntXlibStubsPtr->xCreateColormap) /* 6 */
#endif
#ifndef XCreatePixmapCursor
#define XCreatePixmapCursor \
	(tkIntXlibStubsPtr->xCreatePixmapCursor) /* 7 */
#endif
#ifndef XCreateGlyphCursor
#define XCreateGlyphCursor \
	(tkIntXlibStubsPtr->xCreateGlyphCursor) /* 8 */
#endif
#ifndef XGContextFromGC
#define XGContextFromGC \
	(tkIntXlibStubsPtr->xGContextFromGC) /* 9 */
#endif
#ifndef XListHosts
#define XListHosts \
	(tkIntXlibStubsPtr->xListHosts) /* 10 */
#endif
#ifndef XKeycodeToKeysym
#define XKeycodeToKeysym \
	(tkIntXlibStubsPtr->xKeycodeToKeysym) /* 11 */
#endif
#ifndef XStringToKeysym
#define XStringToKeysym \
	(tkIntXlibStubsPtr->xStringToKeysym) /* 12 */
#endif
#ifndef XRootWindow
#define XRootWindow \
	(tkIntXlibStubsPtr->xRootWindow) /* 13 */
#endif
#ifndef XSetErrorHandler
#define XSetErrorHandler \
	(tkIntXlibStubsPtr->xSetErrorHandler) /* 14 */
#endif
#ifndef XIconifyWindow
#define XIconifyWindow \
	(tkIntXlibStubsPtr->xIconifyWindow) /* 15 */
#endif
#ifndef XWithdrawWindow
#define XWithdrawWindow \
	(tkIntXlibStubsPtr->xWithdrawWindow) /* 16 */
#endif
#ifndef XGetWMColormapWindows
#define XGetWMColormapWindows \
	(tkIntXlibStubsPtr->xGetWMColormapWindows) /* 17 */
#endif
#ifndef XAllocColor
#define XAllocColor \
	(tkIntXlibStubsPtr->xAllocColor) /* 18 */
#endif
#ifndef XBell
#define XBell \
	(tkIntXlibStubsPtr->xBell) /* 19 */
#endif
#ifndef XChangeProperty
#define XChangeProperty \
	(tkIntXlibStubsPtr->xChangeProperty) /* 20 */
#endif
#ifndef XChangeWindowAttributes
#define XChangeWindowAttributes \
	(tkIntXlibStubsPtr->xChangeWindowAttributes) /* 21 */
#endif
#ifndef XClearWindow
#define XClearWindow \
	(tkIntXlibStubsPtr->xClearWindow) /* 22 */
#endif
#ifndef XConfigureWindow
#define XConfigureWindow \
	(tkIntXlibStubsPtr->xConfigureWindow) /* 23 */
#endif
#ifndef XCopyArea
#define XCopyArea \
	(tkIntXlibStubsPtr->xCopyArea) /* 24 */
#endif
#ifndef XCopyPlane
#define XCopyPlane \
	(tkIntXlibStubsPtr->xCopyPlane) /* 25 */
#endif
#ifndef XCreateBitmapFromData
#define XCreateBitmapFromData \
	(tkIntXlibStubsPtr->xCreateBitmapFromData) /* 26 */
#endif
#ifndef XDefineCursor
#define XDefineCursor \
	(tkIntXlibStubsPtr->xDefineCursor) /* 27 */
#endif
#ifndef XDeleteProperty
#define XDeleteProperty \
	(tkIntXlibStubsPtr->xDeleteProperty) /* 28 */
#endif
#ifndef XDestroyWindow
#define XDestroyWindow \
	(tkIntXlibStubsPtr->xDestroyWindow) /* 29 */
#endif
#ifndef XDrawArc
#define XDrawArc \
	(tkIntXlibStubsPtr->xDrawArc) /* 30 */
#endif
#ifndef XDrawLines
#define XDrawLines \
	(tkIntXlibStubsPtr->xDrawLines) /* 31 */
#endif
#ifndef XDrawRectangle
#define XDrawRectangle \
	(tkIntXlibStubsPtr->xDrawRectangle) /* 32 */
#endif
#ifndef XFillArc
#define XFillArc \
	(tkIntXlibStubsPtr->xFillArc) /* 33 */
#endif
#ifndef XFillPolygon
#define XFillPolygon \
	(tkIntXlibStubsPtr->xFillPolygon) /* 34 */
#endif
#ifndef XFillRectangles
#define XFillRectangles \
	(tkIntXlibStubsPtr->xFillRectangles) /* 35 */
#endif
#ifndef XForceScreenSaver
#define XForceScreenSaver \
	(tkIntXlibStubsPtr->xForceScreenSaver) /* 36 */
#endif
#ifndef XFreeColormap
#define XFreeColormap \
	(tkIntXlibStubsPtr->xFreeColormap) /* 37 */
#endif
#ifndef XFreeColors
#define XFreeColors \
	(tkIntXlibStubsPtr->xFreeColors) /* 38 */
#endif
#ifndef XFreeCursor
#define XFreeCursor \
	(tkIntXlibStubsPtr->xFreeCursor) /* 39 */
#endif
#ifndef XFreeModifiermap
#define XFreeModifiermap \
	(tkIntXlibStubsPtr->xFreeModifiermap) /* 40 */
#endif
#ifndef XGetGeometry
#define XGetGeometry \
	(tkIntXlibStubsPtr->xGetGeometry) /* 41 */
#endif
#ifndef XGetInputFocus
#define XGetInputFocus \
	(tkIntXlibStubsPtr->xGetInputFocus) /* 42 */
#endif
#ifndef XGetWindowProperty
#define XGetWindowProperty \
	(tkIntXlibStubsPtr->xGetWindowProperty) /* 43 */
#endif
#ifndef XGetWindowAttributes
#define XGetWindowAttributes \
	(tkIntXlibStubsPtr->xGetWindowAttributes) /* 44 */
#endif
#ifndef XGrabKeyboard
#define XGrabKeyboard \
	(tkIntXlibStubsPtr->xGrabKeyboard) /* 45 */
#endif
#ifndef XGrabPointer
#define XGrabPointer \
	(tkIntXlibStubsPtr->xGrabPointer) /* 46 */
#endif
#ifndef XKeysymToKeycode
#define XKeysymToKeycode \
	(tkIntXlibStubsPtr->xKeysymToKeycode) /* 47 */
#endif
#ifndef XLookupColor
#define XLookupColor \
	(tkIntXlibStubsPtr->xLookupColor) /* 48 */
#endif
#ifndef XMapWindow
#define XMapWindow \
	(tkIntXlibStubsPtr->xMapWindow) /* 49 */
#endif
#ifndef XMoveResizeWindow
#define XMoveResizeWindow \
	(tkIntXlibStubsPtr->xMoveResizeWindow) /* 50 */
#endif
#ifndef XMoveWindow
#define XMoveWindow \
	(tkIntXlibStubsPtr->xMoveWindow) /* 51 */
#endif
#ifndef XNextEvent
#define XNextEvent \
	(tkIntXlibStubsPtr->xNextEvent) /* 52 */
#endif
#ifndef XPutBackEvent
#define XPutBackEvent \
	(tkIntXlibStubsPtr->xPutBackEvent) /* 53 */
#endif
#ifndef XQueryColors
#define XQueryColors \
	(tkIntXlibStubsPtr->xQueryColors) /* 54 */
#endif
#ifndef XQueryPointer
#define XQueryPointer \
	(tkIntXlibStubsPtr->xQueryPointer) /* 55 */
#endif
#ifndef XQueryTree
#define XQueryTree \
	(tkIntXlibStubsPtr->xQueryTree) /* 56 */
#endif
#ifndef XRaiseWindow
#define XRaiseWindow \
	(tkIntXlibStubsPtr->xRaiseWindow) /* 57 */
#endif
#ifndef XRefreshKeyboardMapping
#define XRefreshKeyboardMapping \
	(tkIntXlibStubsPtr->xRefreshKeyboardMapping) /* 58 */
#endif
#ifndef XResizeWindow
#define XResizeWindow \
	(tkIntXlibStubsPtr->xResizeWindow) /* 59 */
#endif
#ifndef XSelectInput
#define XSelectInput \
	(tkIntXlibStubsPtr->xSelectInput) /* 60 */
#endif
#ifndef XSendEvent
#define XSendEvent \
	(tkIntXlibStubsPtr->xSendEvent) /* 61 */
#endif
#ifndef XSetCommand
#define XSetCommand \
	(tkIntXlibStubsPtr->xSetCommand) /* 62 */
#endif
#ifndef XSetIconName
#define XSetIconName \
	(tkIntXlibStubsPtr->xSetIconName) /* 63 */
#endif
#ifndef XSetInputFocus
#define XSetInputFocus \
	(tkIntXlibStubsPtr->xSetInputFocus) /* 64 */
#endif
#ifndef XSetSelectionOwner
#define XSetSelectionOwner \
	(tkIntXlibStubsPtr->xSetSelectionOwner) /* 65 */
#endif
#ifndef XSetWindowBackground
#define XSetWindowBackground \
	(tkIntXlibStubsPtr->xSetWindowBackground) /* 66 */
#endif
#ifndef XSetWindowBackgroundPixmap
#define XSetWindowBackgroundPixmap \
	(tkIntXlibStubsPtr->xSetWindowBackgroundPixmap) /* 67 */
#endif
#ifndef XSetWindowBorder
#define XSetWindowBorder \
	(tkIntXlibStubsPtr->xSetWindowBorder) /* 68 */
#endif
#ifndef XSetWindowBorderPixmap
#define XSetWindowBorderPixmap \
	(tkIntXlibStubsPtr->xSetWindowBorderPixmap) /* 69 */
#endif
#ifndef XSetWindowBorderWidth
#define XSetWindowBorderWidth \
	(tkIntXlibStubsPtr->xSetWindowBorderWidth) /* 70 */
#endif
#ifndef XSetWindowColormap
#define XSetWindowColormap \
	(tkIntXlibStubsPtr->xSetWindowColormap) /* 71 */
#endif
#ifndef XTranslateCoordinates
#define XTranslateCoordinates \
	(tkIntXlibStubsPtr->xTranslateCoordinates) /* 72 */
#endif
#ifndef XUngrabKeyboard
#define XUngrabKeyboard \
	(tkIntXlibStubsPtr->xUngrabKeyboard) /* 73 */
#endif
#ifndef XUngrabPointer
#define XUngrabPointer \
	(tkIntXlibStubsPtr->xUngrabPointer) /* 74 */
#endif
#ifndef XUnmapWindow
#define XUnmapWindow \
	(tkIntXlibStubsPtr->xUnmapWindow) /* 75 */
#endif
#ifndef XWindowEvent
#define XWindowEvent \
	(tkIntXlibStubsPtr->xWindowEvent) /* 76 */
#endif
#ifndef XDestroyIC
#define XDestroyIC \
	(tkIntXlibStubsPtr->xDestroyIC) /* 77 */
#endif
#ifndef XFilterEvent
#define XFilterEvent \
	(tkIntXlibStubsPtr->xFilterEvent) /* 78 */
#endif
#ifndef XmbLookupString
#define XmbLookupString \
	(tkIntXlibStubsPtr->xmbLookupString) /* 79 */
#endif
#ifndef TkPutImage
#define TkPutImage \
	(tkIntXlibStubsPtr->tkPutImage) /* 80 */
#endif
/* Slot 81 is reserved */
#ifndef XParseColor
#define XParseColor \
	(tkIntXlibStubsPtr->xParseColor) /* 82 */
#endif
#ifndef XCreateGC
#define XCreateGC \
	(tkIntXlibStubsPtr->xCreateGC) /* 83 */
#endif
#ifndef XFreeGC
#define XFreeGC \
	(tkIntXlibStubsPtr->xFreeGC) /* 84 */
#endif
#ifndef XInternAtom
#define XInternAtom \
	(tkIntXlibStubsPtr->xInternAtom) /* 85 */
#endif
#ifndef XSetBackground
#define XSetBackground \
	(tkIntXlibStubsPtr->xSetBackground) /* 86 */
#endif
#ifndef XSetForeground
#define XSetForeground \
	(tkIntXlibStubsPtr->xSetForeground) /* 87 */
#endif
#ifndef XSetClipMask
#define XSetClipMask \
	(tkIntXlibStubsPtr->xSetClipMask) /* 88 */
#endif
#ifndef XSetClipOrigin
#define XSetClipOrigin \
	(tkIntXlibStubsPtr->xSetClipOrigin) /* 89 */
#endif
#ifndef XSetTSOrigin
#define XSetTSOrigin \
	(tkIntXlibStubsPtr->xSetTSOrigin) /* 90 */
#endif
#ifndef XChangeGC
#define XChangeGC \
	(tkIntXlibStubsPtr->xChangeGC) /* 91 */
#endif
#ifndef XSetFont
#define XSetFont \
	(tkIntXlibStubsPtr->xSetFont) /* 92 */
#endif
#ifndef XSetArcMode
#define XSetArcMode \
	(tkIntXlibStubsPtr->xSetArcMode) /* 93 */
#endif
#ifndef XSetStipple
#define XSetStipple \
	(tkIntXlibStubsPtr->xSetStipple) /* 94 */
#endif
#ifndef XSetFillRule
#define XSetFillRule \
	(tkIntXlibStubsPtr->xSetFillRule) /* 95 */
#endif
#ifndef XSetFillStyle
#define XSetFillStyle \
	(tkIntXlibStubsPtr->xSetFillStyle) /* 96 */
#endif
#ifndef XSetFunction
#define XSetFunction \
	(tkIntXlibStubsPtr->xSetFunction) /* 97 */
#endif
#ifndef XSetLineAttributes
#define XSetLineAttributes \
	(tkIntXlibStubsPtr->xSetLineAttributes) /* 98 */
#endif
#ifndef _XInitImageFuncPtrs
#define _XInitImageFuncPtrs \
	(tkIntXlibStubsPtr->_XInitImageFuncPtrs) /* 99 */
#endif
#ifndef XCreateIC
#define XCreateIC \
	(tkIntXlibStubsPtr->xCreateIC) /* 100 */
#endif
#ifndef XGetVisualInfo
#define XGetVisualInfo \
	(tkIntXlibStubsPtr->xGetVisualInfo) /* 101 */
#endif
#ifndef XSetWMClientMachine
#define XSetWMClientMachine \
	(tkIntXlibStubsPtr->xSetWMClientMachine) /* 102 */
#endif
#ifndef XStringListToTextProperty
#define XStringListToTextProperty \
	(tkIntXlibStubsPtr->xStringListToTextProperty) /* 103 */
#endif
#ifndef XDrawLine
#define XDrawLine \
	(tkIntXlibStubsPtr->xDrawLine) /* 104 */
#endif
/* Slot 105 is reserved */
#ifndef XFillRectangle
#define XFillRectangle \
	(tkIntXlibStubsPtr->xFillRectangle) /* 106 */
#endif
#endif /* __WIN32__ */
#ifdef MAC_TCL
/* Slot 0 is reserved */
#ifndef XGetModifierMapping
#define XGetModifierMapping \
	(tkIntXlibStubsPtr->xGetModifierMapping) /* 1 */
#endif
#ifndef XCreateImage
#define XCreateImage \
	(tkIntXlibStubsPtr->xCreateImage) /* 2 */
#endif
#ifndef XGetImage
#define XGetImage \
	(tkIntXlibStubsPtr->xGetImage) /* 3 */
#endif
#ifndef XGetAtomName
#define XGetAtomName \
	(tkIntXlibStubsPtr->xGetAtomName) /* 4 */
#endif
#ifndef XKeysymToString
#define XKeysymToString \
	(tkIntXlibStubsPtr->xKeysymToString) /* 5 */
#endif
#ifndef XCreateColormap
#define XCreateColormap \
	(tkIntXlibStubsPtr->xCreateColormap) /* 6 */
#endif
#ifndef XGContextFromGC
#define XGContextFromGC \
	(tkIntXlibStubsPtr->xGContextFromGC) /* 7 */
#endif
#ifndef XKeycodeToKeysym
#define XKeycodeToKeysym \
	(tkIntXlibStubsPtr->xKeycodeToKeysym) /* 8 */
#endif
#ifndef XStringToKeysym
#define XStringToKeysym \
	(tkIntXlibStubsPtr->xStringToKeysym) /* 9 */
#endif
#ifndef XRootWindow
#define XRootWindow \
	(tkIntXlibStubsPtr->xRootWindow) /* 10 */
#endif
#ifndef XSetErrorHandler
#define XSetErrorHandler \
	(tkIntXlibStubsPtr->xSetErrorHandler) /* 11 */
#endif
#ifndef XAllocColor
#define XAllocColor \
	(tkIntXlibStubsPtr->xAllocColor) /* 12 */
#endif
#ifndef XBell
#define XBell \
	(tkIntXlibStubsPtr->xBell) /* 13 */
#endif
#ifndef XChangeProperty
#define XChangeProperty \
	(tkIntXlibStubsPtr->xChangeProperty) /* 14 */
#endif
#ifndef XChangeWindowAttributes
#define XChangeWindowAttributes \
	(tkIntXlibStubsPtr->xChangeWindowAttributes) /* 15 */
#endif
#ifndef XConfigureWindow
#define XConfigureWindow \
	(tkIntXlibStubsPtr->xConfigureWindow) /* 16 */
#endif
#ifndef XCopyArea
#define XCopyArea \
	(tkIntXlibStubsPtr->xCopyArea) /* 17 */
#endif
#ifndef XCopyPlane
#define XCopyPlane \
	(tkIntXlibStubsPtr->xCopyPlane) /* 18 */
#endif
#ifndef XCreateBitmapFromData
#define XCreateBitmapFromData \
	(tkIntXlibStubsPtr->xCreateBitmapFromData) /* 19 */
#endif
#ifndef XDefineCursor
#define XDefineCursor \
	(tkIntXlibStubsPtr->xDefineCursor) /* 20 */
#endif
#ifndef XDestroyWindow
#define XDestroyWindow \
	(tkIntXlibStubsPtr->xDestroyWindow) /* 21 */
#endif
#ifndef XDrawArc
#define XDrawArc \
	(tkIntXlibStubsPtr->xDrawArc) /* 22 */
#endif
#ifndef XDrawLines
#define XDrawLines \
	(tkIntXlibStubsPtr->xDrawLines) /* 23 */
#endif
#ifndef XDrawRectangle
#define XDrawRectangle \
	(tkIntXlibStubsPtr->xDrawRectangle) /* 24 */
#endif
#ifndef XFillArc
#define XFillArc \
	(tkIntXlibStubsPtr->xFillArc) /* 25 */
#endif
#ifndef XFillPolygon
#define XFillPolygon \
	(tkIntXlibStubsPtr->xFillPolygon) /* 26 */
#endif
#ifndef XFillRectangles
#define XFillRectangles \
	(tkIntXlibStubsPtr->xFillRectangles) /* 27 */
#endif
#ifndef XFreeColormap
#define XFreeColormap \
	(tkIntXlibStubsPtr->xFreeColormap) /* 28 */
#endif
#ifndef XFreeColors
#define XFreeColors \
	(tkIntXlibStubsPtr->xFreeColors) /* 29 */
#endif
#ifndef XFreeModifiermap
#define XFreeModifiermap \
	(tkIntXlibStubsPtr->xFreeModifiermap) /* 30 */
#endif
#ifndef XGetGeometry
#define XGetGeometry \
	(tkIntXlibStubsPtr->xGetGeometry) /* 31 */
#endif
#ifndef XGetWindowProperty
#define XGetWindowProperty \
	(tkIntXlibStubsPtr->xGetWindowProperty) /* 32 */
#endif
#ifndef XGrabKeyboard
#define XGrabKeyboard \
	(tkIntXlibStubsPtr->xGrabKeyboard) /* 33 */
#endif
#ifndef XGrabPointer
#define XGrabPointer \
	(tkIntXlibStubsPtr->xGrabPointer) /* 34 */
#endif
#ifndef XKeysymToKeycode
#define XKeysymToKeycode \
	(tkIntXlibStubsPtr->xKeysymToKeycode) /* 35 */
#endif
#ifndef XMapWindow
#define XMapWindow \
	(tkIntXlibStubsPtr->xMapWindow) /* 36 */
#endif
#ifndef XMoveResizeWindow
#define XMoveResizeWindow \
	(tkIntXlibStubsPtr->xMoveResizeWindow) /* 37 */
#endif
#ifndef XMoveWindow
#define XMoveWindow \
	(tkIntXlibStubsPtr->xMoveWindow) /* 38 */
#endif
#ifndef XQueryPointer
#define XQueryPointer \
	(tkIntXlibStubsPtr->xQueryPointer) /* 39 */
#endif
#ifndef XRaiseWindow
#define XRaiseWindow \
	(tkIntXlibStubsPtr->xRaiseWindow) /* 40 */
#endif
#ifndef XRefreshKeyboardMapping
#define XRefreshKeyboardMapping \
	(tkIntXlibStubsPtr->xRefreshKeyboardMapping) /* 41 */
#endif
#ifndef XResizeWindow
#define XResizeWindow \
	(tkIntXlibStubsPtr->xResizeWindow) /* 42 */
#endif
#ifndef XSelectInput
#define XSelectInput \
	(tkIntXlibStubsPtr->xSelectInput) /* 43 */
#endif
#ifndef XSendEvent
#define XSendEvent \
	(tkIntXlibStubsPtr->xSendEvent) /* 44 */
#endif
#ifndef XSetIconName
#define XSetIconName \
	(tkIntXlibStubsPtr->xSetIconName) /* 45 */
#endif
#ifndef XSetInputFocus
#define XSetInputFocus \
	(tkIntXlibStubsPtr->xSetInputFocus) /* 46 */
#endif
#ifndef XSetSelectionOwner
#define XSetSelectionOwner \
	(tkIntXlibStubsPtr->xSetSelectionOwner) /* 47 */
#endif
#ifndef XSetWindowBackground
#define XSetWindowBackground \
	(tkIntXlibStubsPtr->xSetWindowBackground) /* 48 */
#endif
#ifndef XSetWindowBackgroundPixmap
#define XSetWindowBackgroundPixmap \
	(tkIntXlibStubsPtr->xSetWindowBackgroundPixmap) /* 49 */
#endif
#ifndef XSetWindowBorder
#define XSetWindowBorder \
	(tkIntXlibStubsPtr->xSetWindowBorder) /* 50 */
#endif
#ifndef XSetWindowBorderPixmap
#define XSetWindowBorderPixmap \
	(tkIntXlibStubsPtr->xSetWindowBorderPixmap) /* 51 */
#endif
#ifndef XSetWindowBorderWidth
#define XSetWindowBorderWidth \
	(tkIntXlibStubsPtr->xSetWindowBorderWidth) /* 52 */
#endif
#ifndef XSetWindowColormap
#define XSetWindowColormap \
	(tkIntXlibStubsPtr->xSetWindowColormap) /* 53 */
#endif
#ifndef XUngrabKeyboard
#define XUngrabKeyboard \
	(tkIntXlibStubsPtr->xUngrabKeyboard) /* 54 */
#endif
#ifndef XUngrabPointer
#define XUngrabPointer \
	(tkIntXlibStubsPtr->xUngrabPointer) /* 55 */
#endif
#ifndef XUnmapWindow
#define XUnmapWindow \
	(tkIntXlibStubsPtr->xUnmapWindow) /* 56 */
#endif
#ifndef TkPutImage
#define TkPutImage \
	(tkIntXlibStubsPtr->tkPutImage) /* 57 */
#endif
#ifndef XParseColor
#define XParseColor \
	(tkIntXlibStubsPtr->xParseColor) /* 58 */
#endif
#ifndef XCreateGC
#define XCreateGC \
	(tkIntXlibStubsPtr->xCreateGC) /* 59 */
#endif
#ifndef XFreeGC
#define XFreeGC \
	(tkIntXlibStubsPtr->xFreeGC) /* 60 */
#endif
#ifndef XInternAtom
#define XInternAtom \
	(tkIntXlibStubsPtr->xInternAtom) /* 61 */
#endif
#ifndef XSetBackground
#define XSetBackground \
	(tkIntXlibStubsPtr->xSetBackground) /* 62 */
#endif
#ifndef XSetForeground
#define XSetForeground \
	(tkIntXlibStubsPtr->xSetForeground) /* 63 */
#endif
#ifndef XSetClipMask
#define XSetClipMask \
	(tkIntXlibStubsPtr->xSetClipMask) /* 64 */
#endif
#ifndef XSetClipOrigin
#define XSetClipOrigin \
	(tkIntXlibStubsPtr->xSetClipOrigin) /* 65 */
#endif
#ifndef XSetTSOrigin
#define XSetTSOrigin \
	(tkIntXlibStubsPtr->xSetTSOrigin) /* 66 */
#endif
#ifndef XChangeGC
#define XChangeGC \
	(tkIntXlibStubsPtr->xChangeGC) /* 67 */
#endif
#ifndef XSetFont
#define XSetFont \
	(tkIntXlibStubsPtr->xSetFont) /* 68 */
#endif
#ifndef XSetArcMode
#define XSetArcMode \
	(tkIntXlibStubsPtr->xSetArcMode) /* 69 */
#endif
#ifndef XSetStipple
#define XSetStipple \
	(tkIntXlibStubsPtr->xSetStipple) /* 70 */
#endif
#ifndef XSetFillRule
#define XSetFillRule \
	(tkIntXlibStubsPtr->xSetFillRule) /* 71 */
#endif
#ifndef XSetFillStyle
#define XSetFillStyle \
	(tkIntXlibStubsPtr->xSetFillStyle) /* 72 */
#endif
#ifndef XSetFunction
#define XSetFunction \
	(tkIntXlibStubsPtr->xSetFunction) /* 73 */
#endif
#ifndef XSetLineAttributes
#define XSetLineAttributes \
	(tkIntXlibStubsPtr->xSetLineAttributes) /* 74 */
#endif
#ifndef _XInitImageFuncPtrs
#define _XInitImageFuncPtrs \
	(tkIntXlibStubsPtr->_XInitImageFuncPtrs) /* 75 */
#endif
#ifndef XCreateIC
#define XCreateIC \
	(tkIntXlibStubsPtr->xCreateIC) /* 76 */
#endif
#ifndef XGetVisualInfo
#define XGetVisualInfo \
	(tkIntXlibStubsPtr->xGetVisualInfo) /* 77 */
#endif
#ifndef XSetWMClientMachine
#define XSetWMClientMachine \
	(tkIntXlibStubsPtr->xSetWMClientMachine) /* 78 */
#endif
#ifndef XStringListToTextProperty
#define XStringListToTextProperty \
	(tkIntXlibStubsPtr->xStringListToTextProperty) /* 79 */
#endif
#ifndef XDrawSegments
#define XDrawSegments \
	(tkIntXlibStubsPtr->xDrawSegments) /* 80 */
#endif
#ifndef XForceScreenSaver
#define XForceScreenSaver \
	(tkIntXlibStubsPtr->xForceScreenSaver) /* 81 */
#endif
#ifndef XDrawLine
#define XDrawLine \
	(tkIntXlibStubsPtr->xDrawLine) /* 82 */
#endif
#ifndef XFillRectangle
#define XFillRectangle \
	(tkIntXlibStubsPtr->xFillRectangle) /* 83 */
#endif
#endif /* MAC_TCL */

#endif /* defined(USE_TK_STUBS) && !defined(USE_TK_STUB_PROCS) */

/* !END!: Do not edit above this line. */

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLIMPORT

#endif /* _TKINTXLIBDECLS */
