# Encabezado para poder utilizar las funciones de BLT
package require BLT
namespace import blt::*
# -------------------------------------------------------------
# Encabezado para poder utilizar las funciones de Combobox-2.0
source /Nsl3.0/cambios/combobox-2.0/combobox.tcl
package require combobox 2.0
namespace import combobox::*
# -------------------------------------------------------------

proc sp {} {
   set w .sp
   catch {nombre_ventana $w}
   catch {destroy $w}
   catch {_next $w}
   toplevel $w
   wm title $w "Select Plot"

   frame $w.fr0
   frame $w.fr0.fr1
   frame $w.fr0.fr2
   frame $w.fr1
   frame $w.fr2
   frame $w.fr3
   frame $w.fr4
   frame $w.fr5

   set can 0
   label $w.fr0.fr1.lb0 -text "Select the variable either by:" \
   -justify left
   label $w.fr0.fr1.lb1 -text "Expanded variable name:" \
   -justify left
   radiobutton $w.fr0.fr1.rb0 -text "New Canvas" \
   -variable can -value 0 -justify left
   label $w.fr0.fr1.lb2 -text "Select Graph type:" \
   -justify left
   label $w.fr0.fr1.lb3 -text "Tree selection below" \
   -justify left
   label $w.fr0.fr1.lb4 -text "Click + to find name" \
   -justify left
   label $w.fr0.fr2.lb0 -text "typing or tree selection" \
   -justify left
   entry $w.fr0.fr2.e0 -width 30
   radiobutton $w.fr0.fr2.rb0 -text "Current Canvas" \
   -variable can -value 1
   set ::draw Area
   combobox $w.fr0.fr2.c0 \
      -textvariable draw \
      -editable false \
      -highlightthickness 1 \
      -width 28
   eval $w.fr0.fr2.c0 list insert end [list Area Bar Dot Image \
   spatial String Tempotal AreaColor ImageColor Multitemporal XY]

   pack $w.fr0.fr1.lb0 -side top -anchor w
   pack $w.fr0.fr1.lb1 -side top -anchor w
   pack $w.fr0.fr1.rb0 -side top -anchor w
   pack $w.fr0.fr1.lb2 -side top -anchor w
   pack $w.fr0.fr1.lb3 -side top -anchor w
   pack $w.fr0.fr1.lb4 -side top -anchor w
   pack $w.fr0.fr2.lb0 -side top -anchor w
   pack $w.fr0.fr2.e0  -side top -anchor w
   pack $w.fr0.fr2.rb0 -side top -anchor w
   pack $w.fr0.fr2.c0  -side top -anchor w

# ---------------------------------------------------------

# Esto es para desaparecer los folders que estan por default
# esta parte es para los icono no activos
   image create photo foto0
   image create photo foto1
   option add *Hierbox.icons "foto0 foto1"

# Esta parte es para los iconos activos
   image create photo foto2
   image create photo foto3
   option add *Hierbox.activeIcons "foto2 foto3"

# Se crea la lista jerarquica
   hierbox $w.fr1.h \
      -hideroot yes \
      -separator / \
      -opencommand "nombre_ventana $w"

   pack $w.fr1.h -fill both

# Hay que cambiar los tags automaticamentes desde Nsl 
# Nota. -hacer despues los cambios-
# Este separador es para poder poner hijos
   $w.fr1.h configure -separator "/"
#   $w.fr1.h insert end MaxSelectorModel
#   $w.fr1.h insert end MaxSelectorModel/maxSelector

# ---------------------------------------------------------

   button $w.fr2.b0 -text "Close Window" -command "destroy $w"
   button $w.fr2.b1 -text "Next" -command "_next $w"
   pack $w.fr2.b0 -side left
   pack $w.fr2.b1 -side left

   pack $w.fr0 -side top -fill x 
   pack $w.fr0.fr1 -side left -fill x -fill y -padx 2m
   pack $w.fr0.fr2 -side left -fill x -fill y -padx 2m
   pack $w.fr1 -side top -fill both
   pack $w.fr2 -side top
}

# ---------------------------------------------------------

proc nombre_ventana {w} {
   set index [$w.fr1.h curselection]
   set name [eval $w.fr1.h get -full $index]
   set tam [string length $name]
   set j 0
   for {set i 0} {$i < $tam} {incr i 1} {
      if {[string compare [string index $name $i] /]==0} {
         set j $i
      }
   }
   incr j 1
   set short_name [string range $name $j [string length $name]]   
#   variables $short_name $name
}

# ----------------------------------------------------------------------

proc _next {variable_name} {
   set index [$variable_name.fr1.h curselection]
   set name [eval $variable_name.fr1.h get -full $index]
   for {set i 0} {$i < [string length $name]} {incr i 1} {
      if {[string compare [string index $name $i] /]==0} {
         for {set j [expr $i+1]} {$j <= [string length $name]} {incr j 1} {
            if {[string compare [string index $name $j] /]==0} {
               append c_layer . [string range $name [expr $i+1] [expr $j-1]]
               break
            }
            if {$j == [string length $name]} {
               append c_layer . [string range $name [expr $i+1] [string length $name]]
               break
            }
         }
      }
   }
   set c_layer [string range $c_layer 1 [string length $c_layer]]
   for {set i 1} {$i < [string length $name]} {incr i 1} {
      if {[string compare [string index $name $i] /]==0} {
         for {set j [expr $i+1]} {$j <= [string length $name]} {incr j 1} {
            if {[string compare [string index $name $j] /]==0} {
               append c_window . [string range $name [expr $i+1] [expr $j-1]]
               break
            }
            if {$j == [string length $name]} {
               append c_window . [string range $name [expr $i+1] [string length $name]]
               break
            }
         }
      }
   }
   puts $c_window
   puts $c_layer

   nsl create display_window .maxSelector.up \
      -width 600 \
      -height 200 	\
      -wymin -3.0 \
      -wymax 3.0 \
      -wystep .75 \
      -wxstep 10.0 \
      -t1 20.0 \
      -layer MaxSelectorModel.maxSelector.up \
      -graph temporal_graph \
      -grid NSL_ON -x_axis NSL_ON
# nsl run
}

sp