#Programador: Eric Galicia Rosas
#Descripcion: Programa de interfaz grafica para cambiar los valores de las variables en NSL
#Fecha de inicio: 250400
#Fecha de terminacion:

#Este encabezado es necesario para poder hacer las tablas con BLT
package require BLT
namespace import blt::*

proc desplegado {tipo nombre} {
   if {[string compare $tipo data]==0} {
      escalar $nombre
   }
   if {[string compare $tipo vector]==0} {
      vector $nombre 5
   }
#   if {[string compare $nombre /matrix]==0}
#      matrix $nombre 5 5 

}

proc escalar {window_name} {
   toplevel .$window_name
   label .$window_name.l0 -text $window_name
   entry .$window_name.e0
   button .$window_name.b0 -text Ok
   table .$window_name \
   0,0 .$window_name.l0 -fill x \
   0,1 .$window_name.e0 -fill y \
   0,2 .$window_name.b0 -fill both
}

proc vector {window_name m} {
   toplevel .$window_name
   frame .$window_name.fr
   table .$window_name \
      .$window_name.fr
   label .$window_name.fr.l
   label .$window_name.fr.lname -text $window_name -relief groove
   table .$window_name.fr \
	0,0 .$window_name.fr.l -fill both \
	1,0 .$window_name.fr.lname -fill both
   for {set i 1} {$i < $m} {incr i 1} {
      label .$window_name.fr.lc$i -text $i -relief groove
      table .$window_name.fr \
      0,$i .$window_name.fr.lc$i -fill both
   }
#este ciclo es para poner los entry para capturar valores
   for {set i 1} {$i < $m} {incr i 1} {
      entry .$window_name.fr.e$i
      table .$window_name.fr \
      1,$i .$window_name.fr.e$i -fill both
   }
   button .$window_name.b0 -text Ok
   table .$window_name \
      .$window_name.b0 -fill both
}

#===============================================================
# Descripcion: Este procedimiento sirve para cambiar los valores 
# de las variable de tipo matrix de NSL. 
#
# Entradas: Los parametros que recibe a la entrada son el nombre 
# de la variable y el numero de lineas y columnas de esta 
# variable
# 
# Resultados: El resultado es una tabla que permite capturar 
# variables y pasarlas a NSL.
#===============================================================

proc matrix {window_name n m} {
   toplevel .$window_name
#este ciclo es para poner los numeros de las columnas
   button .$window_name.b -text $window_name
   table .$window_name \
	0,0 .$window_name.b -fill x
   for {set i 1} {$i < $m} {incr i 1} {
      button .$window_name.bc$i -text $i
      table .$window_name \
      0,$i .$window_name.bc$i -fill x
   }
#este ciclo es para poner el numero de las filas
   for {set i 1} {$i < $m} {incr i 1} {
      button .$window_name.bl$i -text $i
      table .$window_name \
      $i,0 .$window_name.bl$i -fill x
   }
#este ciclo es para poner los entry para capturar valores
   for {set i 1} {$i < $n} {incr i 1} {
      for {set j 1} {$j < $m} {incr j 1} {
         entry .$window_name.e($i+$j)
         table .$window_name \
         $i,$j .$window_name.e($i+$j) -fill y
      }
   }
}

proc 3-matrix {window_name n m p} {
   toplevel .$window_name
#   scrollbar .$window_name.s -command { .$window_name.t view } -orient horizontal
   tabset .$window_name.t \
      -relief flat \
      -bd 2 \
      -tabborderwidth 1 \
      -textside right \
      -side top \
      -rotate 0  \
      -samewidth yes \
      -tiers 2 \
      -slant right
#      -scrollcommand { .$window_name.s set } \
#      -scrollincrement 1
   pack .$window_name.t -fill both

# Estos ciclos son los que construyen la tabla

   for {set k 0} {$k < $p} {incr k 1} {
      .$window_name.t insert end z$k -text $k -fill both -padx 0.1i -pady 0.1i
      frame .$window_name.t.fr$k
      .$window_name.t tab configure z$k -window .$window_name.t.fr$k
      button .$window_name.t.fr$k.b -text $window_name
      table .$window_name.t.fr$k \
	   0,0 .$window_name.t.fr$k.b -fill x
      set j 0
      for {set i 1} {$i < ($m+1)} {incr i 1} {
         button .$window_name.t.fr$k.b($i+$j) -text $i
         table .$window_name.t.fr$k \
            $j,$i .$window_name.t.fr$k.b($i+$j) -fill both
      }
      set i 0
      for {set j 1} {$j < ($m+1)} {incr j 1} {
         button .$window_name.t.fr$k.b($n+$j) -text $j
         table .$window_name.t.fr$k \
            $j,$i .$window_name.t.fr$k.b($n+$j) -fill both
      }
      for {set j 1} {$j < ($n+1)} {incr j 1} {
         for {set i 1} {$i < ($m+1)} {incr i 1} {
            entry .$window_name.t.fr$k.e($i+$j)
            table .$window_name.t.fr$k \
               $j,$i .$window_name.t.fr$k.e($i+$j) -fill both
         }
      }
   }
}

proc 4-matrix {window_name n m p q} {
   toplevel .$window_name
   tabset .$window_name.t \
      -relief flat \
      -bd 2 \
      -tabborderwidth 1 \
      -textside right \
      -side top \
      -rotate 0  \
      -samewidth yes \
      -tiers 2 \
      -slant right

   pack .$window_name.t -fill both

   for {set l 0} {$l < ($q+1)} {incr l 1} {
      .$window_name.t insert end z$l -text $l -fill both -padx 0.1i -pady 0.1i
      frame .$window_name.t.fr$l
      .$window_name.t tab configure z$l -window .$window_name.t.fr$l
      tabset .$window_name.t.fr$l.ts \
         -relief flat \
         -bd 2 \
         -tabborderwidth 1 \
         -textside right \
         -side right \
         -rotate 0  \
         -samewidth yes \
         -tiers 2 \
         -slant right
      pack .$window_name.t.fr$l.ts -fill both
      for {set k 0} {$k < ($p+1)} {incr k 1} {
         .$window_name.t.fr$l.ts insert end z$k -text $k -fill both -padx 0.1i -pady 0.1i
         frame .$window_name.t.fr$l.ts.fr$k
         .$window_name.t.fr$l.ts tab configure z$k -window .$window_name.t.fr$l.ts.fr$k
         button .$window_name.t.fr$l.ts.fr$k.b -text $window_name
         table .$window_name.t.fr$l.ts.fr$k \
	      0,0 .$window_name.t.fr$l.ts.fr$k.b -fill x
         set j 0
         for {set i 1} {$i < ($m+1)} {incr i 1} {
            button .$window_name.t.fr$l.ts.fr$k.b($i+$j) -text $i
            table .$window_name.t.fr$l.ts.fr$k \
               $j,$i .$window_name.t.fr$l.ts.fr$k.b($i+$j) -fill both
         }
         set i 0
         for {set j 1} {$j < ($m+1)} {incr j 1} {
            button .$window_name.t.fr$l.ts.fr$k.b($n+$j) -text $j
            table .$window_name.t.fr$l.ts.fr$k \
               $j,$i .$window_name.t.fr$l.ts.fr$k.b($n+$j) -fill both
         }
         for {set i 1} {$i < ($n+1)} {incr i 1} {
            for {set j 1} {$j < ($m+1)} {incr j 1} {
               entry .$window_name.t.fr$l.ts.fr$k.e($i+$j)
               table .$window_name.t.fr$l.ts.fr$k \
                  $j,$i .$window_name.t.fr$l.ts.fr$k.e($i+$j) -fill both
            }
         }
      }
   }
}

#4-matrix chido 5 5 5 5
#3-matrix algo 5 5 5
#matrix wfm 5 5
#elegir_desplegado vector mfw
#elegir_desplegado data var_1

#clave para el ripeador ....
# 1245c  54601  54b48 ec510