#include <tk.h>
#include <X11/Xlib.h>
//#include <tcl.h>
#include <malloc.h>
#include <locale.h>
#include <redibujo.h>

C_item::C_item()
{	type_item=0;
	apsig=NULL;
}

C_item::~C_item()
{
}

void C_item::put_id(int v_id)
{	id=v_id;
}

int C_item::get_id()
{	return id;
}

void C_item::put_type_item(int v_type_item)
{	type_item=v_type_item;
}

int C_item::get_type_item()
{	return type_item;
}

void C_item::put_vertices(int v_x0,int v_y0,int v_x1,int v_y1)
{	x0=v_x0;
	y0=v_y0;
	x1=v_x1;
	y1=v_y1;
}

void C_item::get_vertices(int &v_x0,int &v_y0,int &v_x1,int &v_y1)
{	v_x0=x0;
	v_y0=y0;
	v_x1=x1;
	v_y1=y1;
}

void C_item::put_apsig(t_item *apaux)
{	apsig=apaux;
}

t_item *C_item::get_apsig()
{	return apsig;
}

/********************************************************/
C_x_win::C_x_win()
{	cont=0;
	tkwin=NULL;
	apitems=NULL;
	apfitems=NULL;
	apsig=NULL;
}

C_x_win::~C_x_win()
{	
}

void C_x_win::put_id(int v_id)
{	id=v_id;
}

int C_x_win::get_id()
{	return id;
}

void C_x_win::put_token(Tk_Window aptaux)
{	tkwin=aptaux;
}

Tk_Window C_x_win::get_token()
{	return tkwin;
}

void C_x_win::put_apitems(t_item *apaux)
{	apitems=apaux;
}

t_item *C_x_win::get_apitems()
{	return apitems;
}

void C_x_win::put_apfitems(t_item *apaux)
{	apfitems=apaux;
}

t_item *C_x_win::get_apfitems()
{	return apfitems;
}

void C_x_win::put_apsig(t_x_win *apaux)
{	apsig=apaux;
}

t_x_win *C_x_win::get_apsig()
{	return apsig;
}

int C_x_win::add_item(int v_x0,int v_y0,int v_x1,int v_y1,int type_item)
{	t_item *apaux = new t_item;
	apaux->put_id(cont);
	apaux->put_type_item(type_item);
	apaux->put_vertices(v_x0,v_y0,v_x1,v_y1);
	if(apfitems==NULL)
	{	apitems=apaux;
		apfitems=apaux;
	}
	else
	{	apfitems->put_apsig(apaux);
		apfitems=apaux;
	}
//	redraw(tkwin);
	return cont++;
}

int C_x_win::destroy_item(int v_id)
{	t_item *apaux,*apant=NULL;
	for(apaux=apitems;apaux!=NULL;apaux=apaux->get_apsig())
		if(v_id==apaux->get_id())
		{	if(apant==NULL)
				apitems=apaux->get_apsig();
			else
				apant->put_apsig(apaux->get_apsig());
			free(apaux);
			return 1;
		}
		else
			apant=apaux;
	return 0;
}

int C_x_win::modify_item(int v_x0,int v_y0,int v_x1,int v_y1,int v_id)
{	t_item *apaux;
	for(apaux=apitems;apaux!=NULL;apaux=apaux->get_apsig())
		if(v_id==apaux->get_id())
		{	apaux->put_vertices(v_x0,v_y0,v_x1,v_y1);
			return 1;
		}
	return 0;
}

void C_x_win::redraw(Tk_Window tkwin)
{	t_item *apaux;
	int _x0,_y0,_x1,_y1;
	Screen *sc=Tk_Screen(tkwin);
	Display *dpy=Tk_Display(tkwin);		
	Window xwin=Tk_WindowId(tkwin);
    GC gc=XCreateGC(dpy,xwin,0,NULL);		
	XSetForeground(dpy,gc,BlackPixelOfScreen(sc));	
	for(apaux=apitems;apaux!=NULL;apaux=apaux->get_apsig())
	{	apaux->get_vertices(_x0,_y0,_x1,_y1);
		if(apaux->get_type_item()==1)
			XDrawLine(dpy,xwin,gc,_x0,_y0,_x1,_y1);
		else 
			XDrawRectangle(dpy,xwin,gc,_x0,_y0,_x1,_y1);
	}
}

/***************************************************/

C_redraw::C_redraw()
{	flag=0;
	cont=0;
	apwins=NULL;
	apfwins=NULL;
}

C_redraw::~C_redraw()
{
}

void C_redraw::set_flag()
{	flag=1;	
}

void C_redraw::reset_flag()
{	flag=0;
}

int C_redraw::get_flag()
{	return flag;
} 

int C_redraw::add_win(Tk_Window v_tkwin) 
{	t_x_win *apaux = new t_x_win;
	apaux->put_token(v_tkwin);
	apaux->put_id(cont);
	if(apfwins==NULL)
	{	apfwins=apaux;
		apwins=apaux;
		cont++;
		return 1;
	}
	else
	{	apfwins->put_apsig(apaux);
		apfwins=apaux;
		cont++;
		return 1;
	}
	return 0;
}

int C_redraw::destroy_win(int v_id)
{	t_x_win *apaux,*apant=apwins;
	for(apaux=apwins;apaux!=NULL;apaux=apwins->get_apsig())
		if(apaux->get_id()==v_id)
		{	apant->put_apsig(apaux->get_apsig());
			free(apaux);
			return 1;
		}
		else
		{	apant=apaux;
			apaux=apwins->get_apsig();
			return 1;
		}
	return 0;
}

int C_redraw::add_item(int x0,int y0, int x1, int y1,int type_item,Tk_Window id_win)
{	t_x_win *apaux;
	for(apaux=apwins;apaux!=NULL;apaux=apaux->get_apsig())
		if(id_win==apaux->get_token())
			return apaux->add_item(x0,y0,x1,y1,type_item);
	return 0;
}

int C_redraw::destroy_item(int id_win,int id_item)
{	t_x_win *apaux;
	for(apaux=apwins;apaux!=NULL;apaux=apaux->get_apsig())
		if(id_win==apaux->get_id())
			return apaux->destroy_item(id_item);
	return 0;
}

int C_redraw::modify_item(int x0,int y0,int x1,int y1,int id_win,int id_item)
{	t_x_win *apaux;
	for(apaux=apwins;apaux!=NULL;apaux=apaux->get_apsig())
		if(id_win==apaux->get_id())
			return apaux->modify_item(x0,y0,x1,y1,id_item);
	return 0;
}

int C_redraw::redraw(ClientData clientData)
{  t_x_win *apaux;
   Tk_Window tkwin = (Tk_Window) clientData;
   for(apaux=apwins;apaux!=NULL;apaux=apaux->get_apsig())
      apaux->redraw(apaux->get_token());
   return 1;
}

/*
C_redraw o_redraw;

int XDibujaCmd(ClientData clientData,Tcl_Interp *interp,int argc,char **argv)
{   o_redraw.add_item(20,50,70,70,0,2);
    return TCL_OK;
}

int DestruyeCmd(ClientData clientData,Tcl_Interp *interp,int argc,char **argv)
{	clientData=(ClientData) interp;
	o_redraw.destroy_item(1,1);
	return TCL_OK;
}

int ModificaCmd(ClientData clientData,Tcl_Interp *interp,int argc,char **argv)
{	clientData=(ClientData) interp;
	o_redraw.modify_item(40,40,50,50,1,1);
	return TCL_OK;
}
*/