/*********************************************************************
id           - es el identificador del item
type_item    - es el tipo de item
		   1 - lineas
		   2 - cuadros

En el caso de las lineas (x0,y0) son el punto inicial y (x1,y1) el 
punto final.

En el caso de los cuadros (x0,y0) es el vertice superior izquierdo 
y (x1,y1) el vertice inferior derecho. 

apsig - apuntador a la siguient linea o cuadro.
*********************************************************************/

typedef class C_item t_item;
class C_item 
{	int id;
	int type_item;
	int x0,y0,x1,y1;
	t_item *apsig;
public:
	C_item();
	~C_item();
	void put_id(int v_id);
	int  get_id();
	void put_type_item(int v_type_item);
	int  get_type_item();
	void put_vertices(int v_x0,int v_y0,int v_x1,int v_y1);
	void get_vertices(int &v_x0,int &v_y0,int &v_x1,int &v_y1);
	void put_apsig(t_item *apaux);
	t_item *get_apsig();
};

/*********************************************************************
cont     - cuenta el numero de items que esta ventana contiene
id       - identificador unico de esta ventana.
aptwin   - variable para guardar el token de la ventana
apitems  - apuntador al nodo inicial de la lista de items
apfitems - apuntador al nodo final de la lista de items
apsig    - es el apuntador a la siguiente estructura de tipo x_win
*********************************************************************/

typedef class C_x_win t_x_win;
class C_x_win
{   int cont;
	int id;
	Tk_Window tkwin;
	t_item *apitems;
	t_item *apfitems;
	t_x_win *apsig;
public:
	C_x_win();
	~C_x_win();
	void put_id(int v_id);
	int  get_id();
	void put_token(Tk_Window aptaux);
	Tk_Window get_token();
	void put_apitems(t_item *apaux);
	t_item *get_apitems();
	void put_apfitems(t_item *apaux);
	t_item *get_apfitems();
	void put_apsig(t_x_win *apaux);
	t_x_win *get_apsig();
	int add_item(int v_x0,int v_y0,int v_x1,int v_y1,int type_item);
	int destroy_item(int v_id);
	int modify_item(int v_x0,int v_y0,int v_x1,int v_y1,int v_id);
	void redraw(Tk_Window tkwin);
};

/*********************************************************************
Esta clase es la interfaz entre la estructura que guarda los datos
de cada entana y TCL/TK.
*********************************************************************/

class C_redraw
{	int flag;
	int cont;
	t_x_win *apwins;
	t_x_win *apfwins;
public:	
	C_redraw();
	~C_redraw();
	int redraw(ClientData clientData);
	void set_flag();     //funcion que activa la bandera de redesplegado
	void reset_flag();   //funcion que desactiva la bandera de redesplegado
	int get_flag();      //funcion que devuelve el estado de la bandera de redesplegado
	int add_win(Tk_Window v_tkwin) ;
	int destroy_win(int id);
	int add_item(int x0,int y0, int x1, int y1,int type_item,Tk_Window id_win);
	int destroy_item(int id_win,int id_item);
	int modify_item(int x0,int y0,int x1,int y,int id_win,int id_item);  //funcion que permite modificar los atributos del item.
};